(*
This file was created automatically by vma2mma from a .vma
source file.
It should be suitable to be read by Mathematica using the
<< operator but you probably don't want to edit it; edit
the corresponding .vma source file instead!
*)

(* ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; *)
(* ;;                                                                        ;; *)
(* ;;  i.vma                                                                 ;; *)
(* ;;  (C) Timo Felbinger (timo@felbinger.net), 2001                         ;; *)
(* ;;  last modified:  20010430.094613utc  by: timof@uranos                  ;; *)
(* ;;                                                                        ;; *)
(* ;;  This file is free software; you can redistribute it and/or modify     ;; *)
(* ;;  it under the terms of the GNU General Public License as published by  ;; *)
(* ;;  the Free Software Foundation; either version 2, or (at your option)   ;; *)
(* ;;  any later version.                                                    ;; *)
(* ;;                                                                        ;; *)
(* ;;  This program is distributed in the hope that it will be useful,       ;; *)
(* ;;  but WITHOUT ANY WARRANTY; without even the implied warranty of        ;; *)
(* ;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         ;; *)
(* ;;  GNU General Public License for more details.                          ;; *)
(* ;;                                                                        ;; *)
(* ;;  You should have received a copy of the GNU General Public License     ;; *)
(* ;;  along with this file (in a file called LICENSE); if not, write to     ;; *)
(* ;;  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,      ;; *)
(* ;;  Boston, MA 02111-1307, USA, or look at http://www.gnu.org.            ;; *)
(* ;;                                                                        ;; *)
(* ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; *)
(* ;; i.vma is a little hack to make notation of numbers (real and, even *)
(* ;; more so, complex ones) a little less clumsy. *)
(* ;; Intentionally, no context is introduced here, and all symbols are in *)
(* ;; the user's default context except where $PrePrint is used and *)
(* ;; the Global` context must be used. *)

(
 cc::usage = "
 cc[x_] is a more convenient notation for Conjugate[x].
 \ncc[x] is also defined to be the default output format for Conjugate[x].
 \nSee also: i
 ";
)

(
 i::usage = "
 i is a more readable notation for the imaginary constant I.
 \ni is also defined to be the default output format for I.
 \nSee also: cc.
 ";
)

(
 Unprotect[ Conjugate, Complex, Real, i ]
)

(
 i = I
)

(
 cc[x_] := Conjugate[x]
)

(
 scientificNumberString[ x_, exp_String:"e" ] := NumberForm[
 x
 , ExponentFunction -> ( If[ -5 < # < 5, Null, # ] & )
 , NumberFormat -> ( (
   #1
 <> If[ #2=="10", "", "(" <> #2 <> ")" ]
 <> If[ #3 == "" && exp == "e", "", exp ]
 <> #3
 ) & )
 ] // ToString
)

(
 Format[ x_Complex ] := (
 If[ Re[x] == 0, ""
 , scientificNumberString[ Re[x] ]
     <> If[ Im[x] < 0, "", "+" ]
 ] <> If[ Im[x]==1, "i", If[ Im[x]==-1, "-i",
        scientificNumberString[ Im[x], "i" ]
      ] ]
 )
)

(
 Unprotect[ $PrePrint, Global`prePrintList ]
)

(
 ListQ[ Global`prePrintList ] || ( Global`prePrintList = {} )
)

(
 $PrePrint := Composition @@ (
 If[ ListQ[ #1 ], #1 & @@ #1, #1 ] & /@ Global`prePrintList
 )
)

(
 Protect[ $PrePrint, Global`prePrintList ]
)

(

 Global`prePrintList ~Cases~ { _, { "i", "NumberForm" } } == {} && (
 Unprotect[ Global`prePrintList ]
 ; Global`prePrintList = Global`prePrintList ~Prepend~ {
   NumberForm[
     #1
   , ExponentFunction -> ( If[ -5 < # < 5, Null, # ] & )
   , NumberFormat -> ( SequenceForm[
       #1
     , If[ #2=="10", "", "(" <> #2 <> ")" ]
     , If[ #3=="", "", "e" ]
     , #3
     ] & )
   ] &
 , { "i", "NumberForm" }
 }
 ; Protect[ Global`prePrintList ]
 )
)

(
 Protect[ Conjugate, Complex, i, Real ] ;
)
