(*
This file was created automatically by vma2mma from a .vma
source file.
It should be suitable to be read by Mathematica using the
<< operator but you probably don't want to edit it; edit
the corresponding .vma source file instead!
*)


(
 Print[ "
 package qmatrix, version 2.2.0
 \n  (C) Timo Felbinger (timo@felbinger.net), 1999, 2000, 2001
 \n  last modified:  20010430.133542utc  by: timof@uranos
 \n  This package is free software and you are welcome to
 \n  redistribute it; type qmatrix`license for the details.
 \n  Type qmatrix`help to get help on this package.
 " ]
)

(
 qmatrix`license = "
 The package qmatrix is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by  the Free Software Foundation; either version 2,
 or (at your option) any later version.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with this file (in a file called LICENSE); if not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA, or look at http://www.gnu.org.
 ";
)

(
 NameQ[ "qmatrix`version" ] && (
 Print[ "
   It seems that the qmatrix package had already been loaded.
   I will attempt to clear and redefine all symbols from its
   context.
   No guarantee that this will work correctly, better avoid
   reloading the package!
 " ]
 ; Unprotect @@ Names[ "qmatrix`*" ]
 ; Unprotect @@ Names[ "qmatrix`Private`*" ]
 ; Clear @@ Names[ "qmatrix`*" ]
 ; Clear @@ Names[ "qmatrix`Private`*" ]
 )
)

(
 Off[ General::spell1, General::spell ]
)

(
 BeginPackage[ "qmatrix`" ];
)

(
 versionString = If[ "2.2.0" == "$VERS" <> "ION$"
 , Read[ "VERSION", String ]
 , "2.2.0"
 ]
)

(
 version = {
 StringTake[ versionString, {1,#1-1} ] // ToExpression
 , StringTake[ versionString, {#1+1,#2-1} ] // ToExpression
 , StringDrop[ versionString, #2 ] // ToExpression
 } & @@ ( #1 & @@ #1 & /@ StringPosition[ versionString, "." ] )
)

(
 Begin["`Private`"];
)

(
 throw[ x__ ] := ( Print[ x ]; Throw[ { "matrix.m", #1 & [ x ] } ] )
)

(
 qmatrix`Private`preamble::usage = "
 Package qmatrix contains functions to manipulate matrices representing
 quantum states (in general, mixed states, but also pure states)
 of \"structured\" systems, ie systems comprising several
 subsystems.
 \nqmatrix`license contains license information.
 ";
)

(
 qmatrix`Private`postamble::usage = "
 To get started, you may want to first look at the usage of
 system and matrix, or work through the tutorial.
 \nUse the operator ? to get help on a symbol, eg:
 \n    ? qmatrix`system
 \nor simply
 \n    ? system
 \nif the context is not ambiguous.
 \nFor general information on packages and contexts, evaluate
 \n    ? qmatrix`context.
 ";
)

(
 qmatrix`help := (
 ? qmatrix`Private`preamble
 ; Print[ "" ]
 ; Print[ "The following symbols have ::usage messages defined:" ]
 ; Print[ # ] & /@ whatislist
 ; Print[ "" ]
 ; ? qmatrix`Private`postamble
 );
)

(

 usage[sym_,msg_] := (
 ToExpression[ sym <>"::usage = \"" <> msg <> "\"" ]
 ; whatislist = whatislist ~Append~ sym
 )
)

(
 whatislist={};
)

(
 "qmatrix`help" ~usage~ "
 Evaluating symbol qmatrix`help will issue information on the
 qmatrix package (Note that other packages may have a help symbol
 defined too, so you may have to specify the context explicitely).
 ";
)

(
 "qmatrix`version" ~usage~ "
 The symbol qmatrix`version contains the version information of the
 qmatrix package. It contains three numbers: major, minor and release.
 ";
)

(
 "qmatrix`license" ~usage~ ( "
 qmatrix`license is the following string:
 \\n\\n" <> qmatrix`license
 );
)

(
 "qmatrix`context" ~usage~ "
 What you should know about the concept of
 contexts in Mathematica:
 \\nEvery symbol (ie identifier or variable) created by Mathemtica
 lives in a context, which is a concept similar to a namespace
 in C++: it allows symbols with identical names to coexist if they
 live in different name spaces. It can also allow packages to hide
 internal symbols from the user by putting them in a private
 context.
 \\nPackages are collections of symbol definitions in a different
 context. Usually, the name of the context is the same as the name
 of the package. For example, the package qmatrix defines symbols in
 the context qmatrix`. Some symbols are actually in the sub-context
 qmatrix`Private; these symbols are not documented as they are for
 internal use only.
 In the documentation of the package, the context of symbols is usually
 left out and is implicitely assumed to be the package name.
 \\nMathematica supports a current context (Context) and a context
 search path (ContextPath), similar to the current directory and
 PATH in many operating systems.
 \\nBy default, the context Global` is used but this can be changed
 by an assignement to $Context.
 When loading a package, the package's context, but not the private
 sub-context, is automatically appended to the context search path.
 \\nIf a symbol with no explicit context specification
 (this is what you always did before you learned about contexts)
 is seen, Mathematica will internally immediately
 attach a context to it: it will first search in the ContextPath
 for a context which already contains the symbol; if none is
 found, the symbol will be created in the current context.
 Note that this happens immediately when Mathematica sees the
 symbol for the first time, even if it is not evaluated at this
 time; the context of this symbol cannot be changed after that.
 \\nThis means that you have to load a package before using any
 symbol from this package or else you may unintentionally create
 symbols in the wrong name space. This is of course legal but can
 shadow the symbols from the package which you really want to use.
 \\nNote that you can always specify an explicit context if you
 want to make sure to get the symbol you want.
 ";
)

(
 "qmatrix`system" ~usage~ "
 The global variable qmatrix`system is a nested list of modes
 which specifies the physical system under consideration.
 \\nYou can set and re-set this variable at any time by
 calling setSystem[].
 \\nA mode represents the smallest subsystem into which the total
 system can be decomposed, eg a qubit or a single mode in a
 optical resonator. The total Hilbert space is the tensor product of
 all modes in system.
 \\nYou may nest subsystems to represent a successive decomposition
 into ever smaller subsystems (typical case: the total system consists
 of alice and bob, each of which in turn consists of a number of
 qubits).
 \\nNaturally, the same mode must not occur more than once in system.
 \\nSee also: setModeType, setSystem, subSystem
 ";
)

(
 "qmatrix`fermionic" ~usage~ "
 The symbol fermionic is used to define the type of a 2-dimensional
 mode:
 \\n      setModeType[ mode, fermionic ]
 \\nFermionic creators and annihilators will be defined for such
 a mode, as well as Pauli spin operators.
 \\nFermionic modes can be used to represent Qubits.
 \\nSee also: bosonic, setModeType, op
 ";
)

(
 "qmatrix`bosonic" ~usage~ "
 The symbol bosonic is used to define the mode type of a bosonic
 mode with a cutoff:
 \\n      setModeType[ mode, { bosonic, n } ]
 \\nwhere n will denote the number of levels taken into account in
 the matrix representation of tensors living in this mode.
 \\nBosonic creators and annihilators will be defined for such
 a mode, except of course that the result of a creators applied
 to the highest represented state will be zero.
 \\nSee also: fermionic, setModeType, op
 ";
)

(
 "qmatrix`discrete" ~usage~ "
 The symbol discrete is used to define a mode of a given finite
 dimension:
 \\n      setModeType[ mode, { discrete, n } ]
 \\nwhere n will denote the dimenstion of the mode.
 You can use this to represent a n-level atom.
 \\nCreation and annihilation operators will be defined for such a
 mode; however, unlike for a bosonic mode with cutoff n, no
 bose enhancement factors will be involved.
 \\nSee also: setModeType, op
 ";
)

(
 "qmatrix`fixedAngularMomentum" ~usage~ "
 The symbol fixedAngularMomentum is used to define a system with
 fixed angular momentum j, the remaining degree of freedom beeing
 the magnetic quantum number m:
 \\n      setModeType[ mode, { fixedAngularMomentum, j } ]
 \\nwill define a system of fixed total angular momentum j, ie of
 dimension 2j+1.
 \\nThe basis states will be chosen in order of increasing z-component
 (aka quantum number m) of the spin. This is different from the
 convention used in many texts but more consistent with the usual
 convention for fermionic and bosonic modes.
 \\nSee also: op, jPlus, jMinus, jx, jy, jz, setModeType
 ";
)

(
 "qmatrix`setSystem" ~usage~ "
 setSystem[ system_ ] will define the total physical system under
 consideration. system may be any nested list of modes, the sublists
 representing subsystems.
 \\nModes can be represented by any symbols of your
 choice but you have to define a mode type for every mode
 in the system by calling setModeType[].
 \\nYou can change the system you are working with at any time by
 calling this function again.
 \\nSee also: setModeType, system, subSystem
 ";
)

(
 "qmatrix`setModeType" ~usage~ "
 setModeType[ mode_, type_ ] defines the type of mode.
 \\nmode may be any symbol or pattern of your choice.
 \\ntype must be one of the following:
 \\n     fermionic
 \\n     { bosonic, d_Integer }            (where d is the cutoff dimension)
 \\n     { discrete, d_Integer }           (like bosonic, but no bosonic enhancement)
 \\n     { fixedAngularMomentum, j_Real }  (spin of total angular momentum j)
 \\nYou can change the type of a mode at any time; this may of course
 render existing matrices incorrect.
 \\nWhen providing a mode as an argument to a function in this package,
 the mode must be specified literally or by an expression which can
 be evaluated immediately or it may not be recognized.
 \\nA mode is called qualified if it is wrapped by either ket or bra.
 \\nSee also: modeType, ket, bra, fermionic, bosonic, discrete,
 fixedAngularMomentum
 ";
)

(
 "qmatrix`modeType" ~usage~ "
 modeType[ mode_ ] returns the type of the given mode, which must
 have been defined previously by calling setModeType.
 \\nSee also: setModeType
 ";
)

(
 "qmatrix`matrixQ" ~usage~ "
 matrixQ[ x_ ] returns True, iff x matches the pattern
 matrix[ _, List[ (ket|bra)[_]... ] ].
 ";
)

(
 "qmatrix`flatMatrixQ" ~usage~ "
 flatMatrixQ[ x_ ] returns True, iff x matches the pattern
 fm[ _, List[ (ket|bra)[_]... ] ].
 ";
)

(
 "qmatrix`operatorQ" ~usage~ "
 operatorQ[ x_ ] returns True, iff x matches the pattern
 op[ _, _, ___ ].
 ";
)

(
 "qmatrix`modeQ" ~usage~ "
 modeQ[ mode_ ] returns True, iff mode occurs in the system.
 \\nMany functions acting on matrices will remain unevaluated unless
 this function returns True for all involved modes.
 This will avoid errors caused by premature evaluation if you represent
 matrices or their modes by variables or expressions which cannot yet
 be evaluated.
 \\nSee also: matrix, system
 ";
)

(
 "qmatrix`qualifiedModeQ" ~usage~ "
 qualifiedModeQ[ qmode_ ] returns True, iff qmode is of the form
 ket[mode] or bra[mode], and mode occurs in the system.
 \\nSee also: matrix, system, modeQ
 ";
)

(
 "qmatrix`qubitQ" ~usage~ "
 qubitQ[ mode_ ] returns True, iff mode is a mode and is 2-dimensional.
 \\nIn particular, modes of type fermionic can be used to represent
 qubits.
 \\nSee also: setModeType, fermionic, dimension
 ";
)

(
 "qmatrix`modeIndex" ~usage~ "
 modeIndex[ mode_ ] returns the index of mode in the list of all modes
 (which is optained by flattening system), iff mode is, indeed, a
 mode, and remains unevaluated otherwise.
 ";
)

(
 "qmatrix`dimension" ~usage~ "
 dimension[ mode_ ] returns the dimension of mode.
 \\ndimension[ mode___ ] or dimension[ { mode___ } ] returns the dimension of
 the tensor product of the listed modes.
 \\mdimension[ matrix[ c_, m_ ] ] and dimension[ fm[ c_, m_ ] ] return
 the dimension of the tensor space their argument lives in.
 Note that for operators, the result of this function might be unexpected:
 it is the square of the dimension of the space the operator acts on.
 \\nSee also: setModeType, setSystem, matrix, fm
 ";
)

(
 "qmatrix`subSystem" ~usage~ "
 subSystem[ sys_, level_ ] returns the subsystem of system at level
 which contains sys.
 \\nsys is a nested list of modes, which shoulf occur somewhere in
 the total system.
 If sys is not found (or not unique, which should never occur), an exception
 will be thrown.
";
)

(
 "qmatrix`matrix" ~usage~ "
 The pattern matrix[ c_, lm_ ] denotes a generalized matrix:
 lm is a list (which must not be nested) of qualified modes, ie
 modes wrapped by either ket or bra, and c is a nested list of
 coordinates representing, in the computational basis, a tensor
 living in the tensor product of the modes lm.
 \\nlm lists modes in the Mathematica order (which is equal to C
 and opposite from Fortran order)
 for indices of nested lists, ie the first mode corresponds to the
 outermost level and the last mode to the innermost level of nesting.
 \\nExample: for a simple operator acting on only one mode, c is a list
 of lists of cnumbers, which can be interpreted as an ordinary
 matrix, ie a 2-dimensional box full of numbers, stored linewise,
 and the list lm contains two entries, the first one beeing a ket and
 the second one a bra, both of the same mode.
 \\nAs a special case, a 1-dimensional tensor can occur where the
 mode list is empty and c is just a single cnumber (no braces).
 This object is still treated differently from a number; use trace
 to convert this into a cnumber.
 \\nThe nested list of indices, while very suitable for computation,
 can be flattened into the more traditional 2-dimensional form
 by converting the matrix to a flat matrix by calling flatten[].
 \\nNote that objects of the form matrix[c,lm] are very different
 from Mathematica's built-in concept of matrices: they are not
 limited to 2 indices and carry additional knowledge. Most of
 Mathematica's built-in functions operating on matrices will fail
 for these objects. If you want to use such a function, you may
 be able to apply it to the coefficients of an fm object (see
 flatten).
 \\nSee also: op, properMatrixQ, operatorMatrixQ, fm, flatten
 ";
)

(
 "qmatrix`equal" ~usage~ "
 Equal[ matrix[c1_,m1_], matrix[c2_,m2_] ] returns True, iff the two
 arguments are equal.
 \\nEqual first checks whether the argument lists are compatible, ie,
 equal up to a permutation.
 \\nIf the mode lists are found to be compatible, then the coordinate
 lists are subtracted and each coordinate is compared to zero.
 \\nFulllSimplify and all normRules will be applied in this test.
 \\nAs usual, the binary operator == is just another wat to invoke the
 function Equal.
 \\nSee also: matrixPlus, normRules
 ";
)

(
 "qmatrix`fm" ~usage~ "
 The pattern fm[c,m] denotes a matrix in flat representation:
 c is a nested list of depth 2 of coordinates and m a list of
 qualified modes. Similar to matrix[c,m], the flat matrix fm[c,m]
 also represents a tensor living in the tensor product of the modes
 m, but with coordinates in the more traditional 2-dimensional
 representation where the first index of c runs over all ket and
 the second index of c runs over all bra basis states of the space
 the tensor lives in.
 \\nIndices run in C order, ie the last ket or bra space in m
 corresponds to the least significant or fastest changing digit of
 the corresponding index.
 \\nIn m, the kets must be listed first and the bras last.
 \\nRow and column vectors can occur as special cases, if either only
 kets or only bras occur in m.
 \\nThe flat form can be more visually pleasing but is not very useful
 for computation.
 \\nA matrix will be automatically flattened before printing, so you
 will rarely have to work with flat matrices explicitely.
 You can however use flatten to convert a matrix to a fm,
 and nestify to convert a fm to a matrix.
 \\nThe coefficients of a flat matrix resemble Mathematica's built-in
 concept of a matrix, so you can apply Mathematica functions to it:
 eg, Eigenvalues[ #1 & @@ fm[ c, lm ] ] will give you the eigenvalues
 (However, you can also use the function eigenvalus which has been
 defined to act directly on matrix or fm objects).
 \\nSee also: matrix, flatten, nestify
 ";
)

(
 "qmatrix`ket" ~usage~ "
 The pattern ket[ mode_ ] represents a single ket mode, ie the space
 of kets living in mode. This pattern, as well as the corresponding
 bra[ mode_ ], is called a qualified mode.
 \\nIn many cases where you have to specify a mode, you can also specify
 a qualified mode for the same effect.
 \\nmode must be a mode, ie it occurs in system and has a well-defined
 mode type.
 \\nSee also: setModeType, matrix, bra, modeQ
 ";
)

(
 "qmatrix`bra" ~usage~ "
 The pattern bra[mode_] represents a single bra mode, ie the space
 of bras living in mode. This pattern, as well as the corresponding
 ket[mode], is called a qualified mode.
 \\nmode must be a mode, ie it occurs in system and has a well-defined
 mode type.
 \\nSee also: setModeType, matrix, ket, modeQ
 ";
)

(
 "qmatrix`modesValidQ" ~usage~ "
 modesValidQ[ matrix[ c_, m_ ] ] returns True, iff all modes in m are
 modes, which is checked by calling modeQ[].
 \\nIf you represent modes by variables this function will return False
 until all variables can be expanded to definite values.
 \\nmodesValidQ is used mainly internally: many functions
 in this package need to know the modes they are working with and therefore
 will remain unevaluated until this function returns True.
 \\nSee also: modeQ, setSystem, setModeType
";
)

(
 "qmatrix`properMatrixQ" ~usage~ "
 properMatrixQ[ matrix[ c_, m_ ] ] returns True, iff matrix[ c, m ] is
 a well-formed matrix, ie: all modes
 m are qualified modes, every ket and every bra occurs at most once, and
 no braket is present.
 \\nA braket is an occurence in m of a pair of qualified modes
 corresponding to the same mode, where the first member of the pair
 is a bra and the second member is a ket, and no ket or bra of the
 same mode occurs in between them.
 \\nThis function remains unevaluated unless modesValidQ[] returns True
 for the given matrix.
 \\nbrakets in matrices can be contracted, see contractAll.
 (Note: This allows one to perform an inner product of two matrices
 by first computing the outer product, then calling contractAll, but
 this is an inefficient way of doing it).
 \\nSee also: modesValidQ, operatorMatrixQ, matrix, ket, bra
";
)

(
 "qmatrix`operatorMatrixQ" ~usage~ "
 operatorMatrixQ[ matrix[ c_, m_ ] ] returns True, iff matrix[ c, m ]
 is a proper matrix and all modes in m occur in pairs, with the ket preceding
 the bra.
 \\nThis function remains unevaluated unless modesValidQ[] returns True for the
 given matrix.
 \\nSee also: properMatrixQ, matrix, ket, bra, modesValidQ
";
)

(
 "qmatrix`hermitianQ" ~usage~ "
 hermitianQ matrix[ c_, m_ ] ] checks whether the given matrix is equal to
 its Hermitian conjugate.
 \\nThis function remains unevaluated unless modesValidQ[] returns True for the
 given matrix.
 \\nSee also: operatorMatrixQ
";
)

(
 "qmatrix`positiveQ" ~usage~ "
 positiveQ[ matrix[ c_, m_ ] ] returns True, iff matrix[c,m] is a hermitian
 operator matrix with nonnegative eigenvalues.
 \\nThis function remains unevaluated unless modesValidQ[] returns True for the
 given matrix.
 \\nSee also: hermitianQ
";
)

(
 "qmatrix`densityMatrixQ" ~usage~ "
 densityMatrixQ[ matrix[ c_, m_ ] ] returns True, iff matrix[c,m] is positive
 and has trace 1.
 \\nThis function remains unevaluated unless modesValidQ[] returns True for the
 given matrix.
 \\nSee also: positiveQ
";
)

(
 "qmatrix`ketQ" ~usage~ "
 ketQ[ matrix[ c_, m_ ] ] returns True, iff all qualified modes in m are match
 the pattern ket[_] and occur at most once.
 \\nSee also: matrix, ket, braQ
";
)

(
 "qmatrix`braQ" ~usage~ "
 braQ[ matrix[ c_, m_ ] ] returns True, iff all qualified modes in m are match
 the pattern bra[_] and occur at most once.
 \\nSee also: matrix, bra, ketQ
";
)

(
 "qmatrix`reorderMatrix" ~usage~ "
 reorderMatrix[ matrix[ c_, m_ ], neworder_ ] will return a matrix with the modes
 from m reordered to match neworder, which must be a permutation of m. The nested
 list of indices c will be transposed correspondingly.
 \\nThis function will only be evaluated for proper matrices.
 \\nIt will not change the semantics of the matrix,
 unless a ket and a bra of the same mode change places. In the latter case, a
 braket will be created, and the returned matrix is no longer proper.
 \\nNote that this is a basis-independend operation which should not be
 confused with permuteBasis, which permutes vectors of the computational
 basis of a single mode.
 \\nThe relation Equal, usually denoted by the binary operator ==, has been
 defined for matrices such that matrices which are equal up to a reordering
 of the modes are considered equal.
 \\nSee also: permute, matrix, qmatrix`equal
";
)

(
 "qmatrix`partialTranspose" ~usage~ "
 partialTranspose[ matrix[ c_, m_ ], mode_ ] will return the given matrix,
 transposed with respect to mode.
 \\nThere must be exactly one bra and one ket
 of the given mode in m, or an exception will be Throw[]n.
 \\npartialTranspose[ matrix[ c_, m_ ], list_ ] will return the given matrix,
 transposed with respect to all modes occuring in list.
";
)

(
 "qmatrix`hc" ~usage~ "
hc[ matrix[ c_, m_ ] ] returns the Hermitian conjugate of the given matrix.
\\nhc[ mode_ ], where mode is a qualified mode (ie a bra or a ket) returns
the conjugate qualified mode.
\\nhc[ { modes___ } ] where modes___ are qualified modes, returns the list
in reverse order and with all modes conjugated.
";
)

(
 "qmatrix`permuteBasis" ~usage~ "
 permuteBasis[ matrix[ c_, m_ ], qmode_, perm_ ] applies the given
 permutation to the basis vectors of the qualified mode qmode, which
 must occur exactly once in m.
 \\nBy convention, a permutation s acts on basis states like s|j>=|s(j)>,
 eg if s={7,3,4,9,...}, then s|1>=|7>.
 \\nConsequently, the reverse mapping must be applied to the coordinates,
 which is what this function does:
 \\n     s|\\psi>=\\sum_j c_j |s(j)> = \sum_j c_{s^{-1}(j)} |j>
 \\nNote that this is an inherently basis-dependend operation and
 should not be confused with reorderMatrix, which changes the order
 of tensor indices.
 \\nSee also: permute, reorderMatrix
";
)

(
 "qmatrix`warpOperatorMatrix" ~usage~ "
 warpOperatorMatrix[ matrix[ c_, m_ ], newspace_ ] returns an extended matrix
 living in newspace. matrix[c,m] must be an operator matrix and newspace any
 list of modes, qualified or not. The space of the result will contain one ket
 and one bra for every mode mentioned in newspace, which must be a superset of m.
 \\nIdentity operators will multiplied in as needed, and the nested list of
 coordinates will be transposed to match the order of modes in newspace.
 \\nThis function is mainly intented for internal use in adding matrices.
 \\nSee also: matrixPlus
";
)

(
 "qmatrix`matrixPlus" ~usage~ "
 matrixPlus[ matrix[ c1_, m1_ ] , matrix[ c2_, m2_ ] ] returns the sum of
 the two given matrices.
 \\nThis sum can be computed if either m1 and m2 are
 identical up to a permutation (in which case the order of modes of the
 result will be determined by m1), or both matrices are operator matrices
 (which will be expanded to the least common multiple of the spaces defined
 by m1 and m2 by multiplying with suitable identity operators).
 \\nIf neither condition holds, the matrices cannot be added and an
 exception will be Throw[]n.
 \\nmatrixPlus[ m1, m2, ... ] returns the sum of all given matrices,
 computed recursively.
 \\nAs for ordinary numbers, the binary operator + is just another way
 to invoke the function Plus.
 \\nSee also: warpOperatorMatrix
";
)

(
 "qmatrix`commutator" ~usage~ "
 commutator[ matrix[ c1_, m1_ ] , matrix[ c2_, m2_ ] ] returns the
 commutator of the given matrices.
 ";
)

(
 "qmatrix`contractAll" ~usage~ "
 contractAll[ matrix[ c_, m_ ] ] returns a matrix computed by
 contracting all brakets present in matrix[c,m].
 \\nA braket is an occurence in m of a pair of qualified modes
 corresponding to the same mode, where the first member of the pair
 is a bra and the second member is a ket, and no ket or bra of the
 same mode occurs in between them.
 \\nAll normRules will be applied in an attempt to simplify the
 result by making use of known normalization properties.
 \\nSee also: normRules, contractAll
";
)

(
 "qmatrix`contract" ~usage~ "
 contract[ matrix[ c_, m_ ], mode__ ] returns the given matrix,
 contracted recursively over all given modes.
 \\nFor every such mode,
 there must either be exactly one bra and one ket in m, or no bra and no
 ket (in the latter case, the mode is silently ignored);
 otherwise, an exception will be Throw[]n.
 \\ncontract[ matrix[ c_, m_ ], list_ ] contracts over all modes in the
 given list. list may be nested, ie, it may be a subsystem. In the
 special case list == system, the trace of matrix[c,m] will be
 computed.
 \\ncontract[ matrix[ c_, m_ ], Not[ list_ ] ] contracts over all modes in m
 which are not in list. Again, list may be nested.
 \\nAll normRules will be applied in an attempt to simplify the
 result by making use of known normalization properties.
 \\nSee also: normRules, contractAll
 ";
)

(
 "qmatrix`trace" ~usage~ "
 trace[ matrix[ c_, m_ ] ] returns the trace of matrix[c,m], which must be
 an operator matrix.
 \\nAll normRules will be applied in an attempt to simplify the
 result by making use of known normalization properties.
 \\nSee also: contract, normRules
 ";
)

(
 "qmatrix`projector" ~usage~ "
 projector[ matrix[ c_, m_List] ] returns a projector onto the
 one-dimensional space spanned by matrix[ c, m ], which must be
 a ket or a bra but need not be normalized.
 \\nprojector[ list_List ] returns a projector onto the space
 spanned by all members of the list. List may contain any mixture
 of kets and bras, which need not be orthogonal.
 \\nSee also: ket, bra
 ";
)

(
 "qmatrix`outerMatrixProduct" ~usage~ "
 outerMatrixProduct[ m___ ] returns the outer product, or Kronecker product,
 of all given arguments, which must be matrices.
 \\nbrakets may be created and will not be contracted by this function.
 You can always call contractAll at a later time to get rid of the
 brakets.
 \\nThis function is rarely useful for end users: most likely,
 diracMatrixProduct (denoted by **) is what you want.
 \\nSee also: diracMatrixProduct, contract, contractAll
 ";
)

(
 "qmatrix`diracMatrixProduct" ~usage~ "
 diracMatrixProduct[ m___ ], where all m are matrixes, returns the Dirac
 product of all given matrices, which is equivalent to the outer product
 with all brakets contracted.
 \\nThe binary operator ** is another way to invoke the function
 diracMatrixProduct.
 \\nSee also: contractAll, norm, outerMatrixProduct
 ";
)

(
 "qmatrix`normalize" ~usage~ "
 normalize[ matrix[ c_, m_ ] ] returns the given matrix, normalized.
 matrix[c,m] must either be an operator matrix with finite trace
 (which will be normalized to have trace 1),
 or a ket or a bra (which will be normalized with respect to the
 standard scalar product), or else an exception will be Throw[]n.
 \\nSee also: trace, ket, bra, gramSchmidt
 ";
)

(
 "qmatrix`normSquare" ~usage~ "
 normSquare[ matrix[ c_, m_ ] ] returns the square of the norm of the
 specified matrix, which must be a ket or a bra.
 \\nSee also: ket, bra, norm, normalize
 ";
)

(
 "qmatrix`norm" ~usage~ "
 norm[ matrix[ c_, m_ ] ] returns the norm of the
 specified matrix, which must be a ket or a bra.
 \\nSee also: ket, bra, normSquare, normalize
 ";
)

(
 "qmatrix`inverse" ~usage~ "
 inverse[ matrix[ c_, m_ ] ] returns the inverse of the given matrix,
 which must be an operator matrix.
 ";
)

(
 "qmatrix`gramSchmidt" ~usage~ "
 gramSchmidt[ list_List ], where list must be a list of kets,
 returns the list of kets obtained from the argument list by
 Gram-Schmidt orthonormalization.
 \\nIf the argument list contains linear dependencies, the
 returned list will be shorter than the argument list.
 Numerical errors up to qmatrix`Private`epsilon are neglected
 when checking for linear dependencies.
 \\nSee also: normalize, ket, diracMatrixProduct
 ";
)

(
 "qmatrix`schmidtDecomposition" ~usage~ "
 schmidtDecomposition[ matrix[ c_, m_ ], space_ ], where
 matrix[ c, m ] must be a ket and space must be a --- possibly nested ---
 list of modes, returns the Schmidt decomposition relative to space:
 \\nIt will return a list of tripels, where each tripel comprises an
 eigenket of the state reduced to space, the corresponding eigenket of
 the state reduced to Not[space], and the corresponding eigenvalue.
 All eigenkets will be normalized.
 \\nThe returned list will also contain members whose eigenvalues
 are essentially zero; it is your choice whether to discard them.
 Function schmidtRank will return the number of non-zero eigenvalues.
 \\n
 See also: schmidtRank, normalizedEigensystem, gramSchmidt
 ";
)

(
 "qmatrix`schmidtRank" ~usage~ "
 schmidtRank[ matrix[ c_, m_ ], space_ ], where
 matrix[ c, m ] must be a ket and space must be a --- possibly nested ---
 list of modes, returns the Schmidt rank relative to space.
 The Schmidt rank is the number of non-zero eigenvalues in the
 Schmidt decomposition. An eigenvalue is considered non-zero,
 if its modulus is larger than qmatrix`Private`epsilon (current
 value: " <> ToString[ epsilon ] <> ").
 ";
)

(
 "qmatrix`flatten" ~usage~ "
 flatten[ matrix[ c_, m_ ] ] returns a flat matrix equivalent to
 the given matrix. This function will only be evaluated for proper
 matrices.
 \\nThe default output Format of a matrix is flattened.
 \\nSee also: matrix, fm, nestify, Format
 ";
)

(
 "qmatrix`nestify" ~usage~ "
 nestify[ fm[ c_, m_ ] ] returns a regular matrix (with a nested list
 of coordinated) equivalent to the given flat matrix.
 \\nSee also: matrix, fm, flatten
 ";
)

(
 "qmatrix`pretty" ~usage~ "
 pretty[ matrix[ c_, m_ ] ] will attempt to pretty-print the given
 matrix: the matrix will be flattened and Simplified, numerical
 approximations for all coordinates will be printed, and the output
 will be in MatrixForm.
 The mode list will be printed in a line below the coordinates.
 \\npretty also accepts a second argument:
 pretty[ matrix[ c_, m_ ], width_ ] will pretty-print
 the given matrix, with PageWidth temporarily changed to the
 specified width. This allows you to avoid line wraps without
 globally changing the PageWidth.
 This feature seems to have no effect in the notebook front end.
 \\nSimilarely, pretty[ fm[ c_, m_ ] ] will attempt to pretty-print the
 given flat matrix.
 \\npretty[ matrix[...], 2^15 ] is the default Format for matrix and
 fm, which will usually avoid all line breaks.
 \\nSee also: matrix, fm, flatten
 ";
)

(
 "qmatrix`eigensystem" ~usage~ "
 eigensystem[ matrix[ c_, m_ ] ] returns a list of pairs, where every
 pair contains an eigenket and the corresponding eigenvalue of the
 matrix[c,m], which must be a proper operator matrix.
 \\nsimilarely, eigensystem[ fm[ c_, m_ ] ] returns a list of pairs,
 where every pair contains a flat eigenvector and the corresponding
 eigenvalue of the flat matrix fm[c,m], which must be a proper
 operator matrix.
 \\nNote that the eigenvectors are not guaranteed to be normalized.
 \\nSee also: operatorMatrixQ, eigenvectors, eigenvalues,
 normalizedEigensystem
";
)

(
 "qmatrix`eigenvectors" ~usage~ "
 eigenvectors[ matrix[ c_, m_ ] ] returns a list of eigenkets of
 matrix[c,m], which must be a proper operator matrix.
 \\nNote that the eigenvectors are not guaranteed to be normalized.
 \\nSee also: operatorMatrixQ, matrix, fm, eigensystem
";
)

(
 "qmatrix`eigenvalues" ~usage~ "
 eigenvalues[ matrix[ c_, m_ ] ] returns a list of eigenvalues of
 matrix[c,m], which must be a proper operator matrix.
 \\nSee also: operatorMatrixQ, matrix, fm, eigensystem
";
)

(
 "qmatrix`normalizedEigensystem" ~usage~ "
 normalizedEigensystem[ matrix[ c_, m_ ] ] returns a list of pairs,
 where every pair contains a normalized eigenket and the
 corresponding eigenvalue of the matrix[c,m], which must be a
 proper operator matrix.
 \\nSee also: eigensystem, eigenvectors, eigenvalues
";
)

(
 "qmatrix`log" ~usage~ "
 Log[ matrix[ c_, m_ ] ] or log[ matrix[ c_, m_ ] ] return a natural
 logarithm of the given matrix, which must be an operator matrix.
 \\nThe logarithm is not unique: it is only determined up to a
 multiple of 2*Pi*i, so Log is not always the inverse of Exp.
 For positive hermitian matrices, the Hermitian principal value will
 be returned.
 \\nIf the matrix is singular, the result will involve the symbol
 logOfNull, which is -Infinity except that it vanishes when
 multiplied by zero.
 \\nThis function fails for matrices which cannot be diagonalized.
 \\nNote that this is a logarithm to base e; in quantum information,
 you will usually prefer ld which computes a logarithm to base 2.
 \\nSee also: ld, exp, operatorMatrixQ
";
)

(
 "qmatrix`ld" ~usage~ "
 ld[ matrix[ c_, m_ ] ] returns a logarithm to base 2
 of the given matrix, which must be an operator matrix.
 \\nThe logarithm is not unique; however,
 for positive hermitian matrices, the Hermitian principal value will
 be returned.
 \\nIf the matrix is singular, the result will involve the symbol
 logOfNull, which is -Infinity except that it vanishes when
 multiplied by zero.
 \\nThis function fails for matrices which cannot be diagonalized.
 \\nSee also: log, exp, operatorMatrixQ
";
)

(
 "qmatrix`exp" ~usage~ "
 Exp[ matrix[ c_, m_ ] ] or exp[ matrix[ c_, m_ ] ] return the
 exponential function of the given matrix, which must be an
 operator matrix.
 \\nThis function fails for matrices which cannot be diagonalized.
 \\nSee also: log, operatorMatrixQ
";
)

(
 "qmatrix`sqrt" ~usage~ "
 Sqrt[ matrix[ c_, m_ ] ] or sqrt[ matrix[ c_, m_ ] ] return the
 square root of the given matrix, which must be an operator matrix.
 \\nThe square root is computed by diagonalizing the matrix and taking
 square roots of the eigenvalues, with the branch cut on the negative
 real axis.
 \\nThis function fails for matrices which cannot be diagonalized.
";
)

(
 "qmatrix`op" ~usage~ "
 The pattern qmatrix`op[___] denotes an abstract operator. Operators of
 the form op[ name_, mode_, ___ ] act only on mode (which should be
 a mode) and name determines the type of operator.
 \\nDefined names are:
 \\n      id:    identity, does nothing
 \\n      a:     annihilation operator
 \\n      ad:    creation operator
 \\n      basis: basis tensor: projector or generalized projector
 \\n             onto basis states
 \\n      permutation:
 \\n             a permutation of basis states
 \\n      jPlus, jMinus, jx, jy, jz:
 \\n             the usual angular momentum operators
 \\n
 \\nThese operators will be turned into the representation in the
 computational basis if they appear as the argument
 of matrix; eg matrix[ op[ a, mode ] ] is the matrix of an annihilation
 operator.
 \\nSee also: id, a, ad, basis, permutation, jPlus, jMinus, jx, jy, jz
 ";
)

(
 "qmatrix`id" ~usage~ "
 id is the name of the identity operator.
 The abstract operator op[id,mode] is defined for modes
 of any type and acts as the identity map.
 \\nSee also: op
 ";
)

(
 "qmatrix`a" ~usage~ "
 a is the name of the annihilation (or "ladder-down") operator.
 The abstract operator op[a,mode] is the annihilation
 operator on mode; it maps basis states of the computational basis
 onto states with quantum number reduced by one, multiplied by
 a scalar factor depending on mode type.
 \\nSee also: op
 ";
)

(
 "qmatrix`ad" ~usage~ "
 ad is the name of the creation (or "ladder-up") operator.
 The abstract operator op[ad,mode] is the creation
 operator on mode; it maps basis states of the computational basis
 onto states with quantum number increased by one, multiplied by
 a scalar factor depending on mode type.
 \\nSee also: op
 ";
)

(
 "qmatrix`jPlus" ~usage~ "
 jPlus is the name of the `ladder up' operator of a spin.
 \\nop[jPlus,mode] is the spin ladder operator on mode, even if
 this mode is not of type fixedAngularMomentum: the mode will be
 treated `as if' it was a spin with  total angular momentum
 j = (dimension[mode]-1)/2.
 \\nFor modes of type fixedAngularMomentum, jPlus is equivalent
 to ad.
 \\nSee also: fixedAngularMomentum, jMinus, ad, op
 ";
)

(
 "qmatrix`jMinus" ~usage~ "
 jMinus is the name of the `ladder down' operator of a spin.
 \\nop[jMinus,mode] is the spin ladder operator on mode, even if
 this mode is not of type fixedAngularMomentum: the mode will be
 treated `as if' it was a spin with total angular momentum
 j = (dimension[mode]-1)/2.
 \\nFor modes of type fixedAngularMomentum, jMinus is equivalent
 to a.
 \\nSee also: fixedAngularMomentum, jPlus, a, op
 ";
)

(
 "qmatrix`jz" ~usage~ "
 jz is the name of the operator of the z-component of a spin.
 \\nop[jz,mode] is the spin-z operator on mode, even if
 this mode is not of type fixedAngularMomentum: the mode will be
 treated as if it was a spin with  total angular momentum
 j = (dimension[mode]-1)/2.
 \\nSee also: fixedAngularMomentum, op
 ";
)

(
 "qmatrix`jx" ~usage~ "
 jx is the name of the operator of the x-component of a spin.
 \\nop[jx,mode] is the spin-x operator on mode, even if
 this mode is not of type fixedAngularMomentum: the mode will be
 treated as if it was a spin with  total angular momentum
 j = (dimension[mode]-1)/2.
 \\nSee also: fixedAngularMomentum, op
 ";
)

(
 "qmatrix`jy" ~usage~ "
 jy is the name of the operator of the y-component of a spin.
 \\nop[jy,mode] is the spin-y operator on mode, even if
 this mode is not of type fixedAngularMomentum: the mode will be
 treated as if it was a spin with  total angular momentum
 j = (dimension[mode]-1)/2.
 \\nSee also: fixedAngularMomentum, op
 ";
)

(
 "qmatrix`basis" ~usage~ "
 op[basis,mode,j] represents the projector on state j of the computational
 basis of mode.
 \\nBasis states are numbered 1..dimension[mode]
 \\nop[basis,mode,j,k] represents the skew projector which maps basis
 state k onto j and all other basis states onto 0.
 \\nSee also: op
 ";
)

(
 "qmatrix`permutation" ~usage~ "
 op[permutation,mode,perm] represents the operator which permutes basis
 states of mode using the permutation perm.
 \\nSee also: op
 ";
)

(
 "qmatrix`stateSwapper" ~usage~ "
 stateSwapper[ m1_, m2_ ] returns a matrix representing, in the
 computational basis, the state swapper between the modes m1 and m2.
 m1 and m2 must be of equal dimension.
";
)

(
 "qmatrix`notGate" ~usage~ "
 notGate[ mode_ ], where mode must be a fermionic mode, ie a Qubit,
 returns a
 matrix representing, in the computational basis, the not operation
 (aka a Pi-pulse), acting on mode.
";
)

(
 "qmatrix`cnotGate" ~usage~ "
 cnotGate[ qubit_, control_ ], where both qubit and control must be
 qubits (ie 2-dimensional), returns a matrix representing, in the
 computational basis, the cnot operation acting on qubit controlled
 by control.
";
)

(
 "qmatrix`fourierTransform" ~usage~ "
 fourierTransform[ mode_ ] is the matrix of the unitary operator of
 the discrete fourier transform on mode.
";
)

(
 "qmatrix`basisKet" ~usage~ "
 basisKet[ n_, mode_ ] returns the matrix representing the basis ket
 |n> in mode.
 \\nbasis vectors are numbered 1..dimension[mode].
 ";
)

(
 "qmatrix`basisBra" ~usage~ "
 basisBra[ n_, mode_ ] returns the matrix representing the basis bra
 <n| in mode.
 \\nbasis vectors are numbered 1..dimension[mode].
 ";
)

(
 "qmatrix`nullMatrix" ~usage~ "
 nullMatrix[ modelist_ ], where modelist is a list of qualified modes,
 returns the matrix representing the null tensor living in the specified
 modes.
 \\nIf the list is empty, matrix[ 0, {} ] is returned.
 \\nnullMatrix[ modes___ ] is equivalent to nullMatrix[ { modes } ].
 ";
)

(
 "qmatrix`identityMatrix" ~usage~ "
 identityMatrix[ modelist_ ], where modelist is a list of modes,
 returns the matrix representing the identity operator on the specified
 modes.
 \\nIf the list is empty, matrix[ 1, {} ] is returned.
 \\nmodelist can contain any combination of ket, bra, and unqualified
 modes; every mode mentioned will occur in the resulting operator matrix
 exactly once as a ket and once as a bra.
 \\nidentityMatrix[ modes___ ] is equivalent to identityMatrix[ { modes } ].
 ";
)

(
 "qmatrix`generalState" ~usage~ "
 generalState[ mode_, name_ ] returns a matrix, representing a
 mixed state living in mode, with unknown entries formed by
 appending row and column indices to the given base name.
 \\nSee also: generalKet, generalBra, generalPureState
 ";
)

(
 "qmatrix`generalKet" ~usage~ "
 generalKet[ mode_, name_ ] returns a matrix, representing a ket
 vector living in mode, with all entried formed by
 appending the row index to the given base name.
 \\nSee also: generalState, generalPureState, generalBra
 ";
)

(
 "qmatrix`generalBra" ~usage~ "
 generalBra[ mode_, name_ ] returns a matrix, representing a bra
 vector living in mode, with all entried formed by
 appending the row index to the given base name.
 \\nSee also: generalState, generalPureState, generalBra
 ";
)

(
 "qmatrix`generalPureState" ~usage~ "
 generalPureState[ mode_, name_ ] returns the density matrix of a
 pure state living in mode, formed by computing
 the outer matrix product of generalPureKet[mode,name] and its
 hermitian conjugate.
 \\nSee also: generalState, generalKet, generalBra
 ";
)

(
 "qmatrix`perfectMixture" ~usage~ "
 perfectMixture[ mode_ ] returns a matrix living in mode,
 representing a perfect mixed state of this mode.
 \\nSee also: identityMatrix, generalState, randomKet
 ";
)

(
 "qmatrix`bellStateKet" ~usage~ "
 bellStateKet[ ma_, mb_, n_:1 ] returns a matrix, representing
 a ket equal to one of
 the 4 bell states, the first and default one being the singlet.
 ";
)

(
 "qmatrix`singletKet" ~usage~ "
 singletKet[ ma_, mb_ ] returns a matrix representing the singlet
 state of the modes ma and mb, which must be 2-dimensional.
 ";
)

(
 "qmatrix`bellState" ~usage~ "
 bellState[ ma_, mb_, n_:1 ] returns a matrix representing a state
 operator equal one of the 4 bell states, the first and default one
 beeing the singlet state.
 \\nma and mb must be modes (they need not necessarily be qubits,
 but only the first two basis states will be used). n is a integer
 with 1<=n<=4.
 ";
)

(
 "qmatrix`singlet" ~usage~ "
 singlet[ ma_, mb_ ] returns a matrix representing a state operator
 equal to the singlet state of the modes ma and mb.
 \\nCurrently, this is implemented for 2-dimensional modes only.
 ";
)

(
 "qmatrix`wernerState" ~usage~ "
 wernerState[ lambda_, m1_, m2_ ] returns the Werner state living in
 the modes m1 and m2 with parameter lambda. A wernerState is a
 mixture of a singlet and a perfect mixture, with the parameter
 0 <= lambda <= 1 determining the weight of the perfect mixture.
 m1 and m2 should be qubits.
 \\nSee also: singlet, identityMatrix, qubitQ
 ";
)

(
 "qmatrix`det" ~usage~ "
 det[ matrix[ c_, m_ ] ] returns the determinand of matrix[c,m] which
 should be an operator matrix.
 ";
)

(
 "qmatrix`neumannEntropy" ~usage~ "
 neumannEntropy[ matrix[ c_, m_ ] ] returns the von-Neumann entropy
 of matrix[c,m], which should be an operator matrix.
 ";
)

(
 "qmatrix`relativeEntropy" ~usage~ "
 relativeEntropy[ matrix[ c1_, m1_ ], matrix[ c2_, m2_ ] ] returns
 the relative entropy of matrix[c1,m1] relative to matrix[c2,m2],
 which should both be operator matrices.
 ";
)

(
 "qmatrix`factorizes" ~usage~ "
 factorizes[ matrix[ c_, m_ ], space_ ] returns True, iff the given
 matrix, which must be either a proper operator matrix, or a ket or
 a bra, can be factorized in a tensor product of a matrix living in
 space (or a subspace thereof), and a matrix living outside of space.
 \\nSpace can be any nested list of modes.
 \\nNumerical errors up to qmatrix`Private`epsilon are discarded.
 \\nThis function fails and Throw[]s an exception when applied to
 traceless operators.
";
)

(
 "qmatrix`qcstate" ~usage~ "
 an object of the form
 qcstate[ { { matrix1, knowledge1 }, { matrix2, knowledge2 }, ... } ]
 represents a state with combined quantum and classical information.
 The matrixi are quantum states of the type matrix[ c_, m_ ]
 (which should be state operators). The knowledgei are rule lists of
 the type { pointer1->value1, pointer2->value2, ... }, mapping
 arbitrary labels pointeri onto values (usually eigenvalues of some
 measurement).
 \\nqcstates are typically created by measurements.
 \\nqcstate[ matrix[ c_, m_ ] ] creates a simple qcstate, containing
 just one quantum state and an empty knowledge list.
 \\nMany functions that can be applied to matrices can also be applied
 to qcstates, eg contract, factorizes, dimension.
 \\nSee also: measure, matrix, forget, properQcstateQ
 ";
)

(
 "qmatrix`measure" ~usage~ "
 measure[ matrix[ c_, m_ ], { what_, pointer_ } ]
 returns the result of a measurement on the state matrix[ c, m ].
 \\nwhat can be either a mode (in which case the pointer basis is
 the computational basis of the mode and the result is a number
 1..dimension[mode]) or an observable.
 \\npointer is an arbitrary label for the outcome of the measurement.
 \\nThe result of this function is a qcstate of the form
 \\n  qcstate[{{matrix1,{pointer->value1}},matrix2,{pointer->value2},...}]
 \\nThere will be exactly one entry for each possible pointer value.
 \\nThe measurement is nondestructive, ie matrixi is an eigenstate of
 the measured observable corresponding to eigenvalue valuei, ie the
 classical information is encoded in the quantum states, too. For a
 destructive measurement, you have to trace over the measured degree
 of freedom.
 \\nSee also: matrix, qcstate, forget
 ";
)

(
 "qmatrix`properQcstateQ" ~usage~ "
 properQcstateQ[ qcstate[ states_List ] ] returns True, if the
 argument has the form of a qcstate (ie is a list of lists, where
 every sublist contains a matrix and a list of replacement rules),
 all quantum states are indeed operators, the argument is normalized
 (ie the sum of the traces of all quantum states is 1), and all
 quantum states live in the same Hilbert space.
 \\nSee also: qcstate, operatorMatrixQ
 ";
)

(
 "qmatrix`collectIdenticalKnowledge" ~usage~ "
 collectIdenticalKnowledge[ qcstate[ states_List ] ] returns
 a qcstate which is derived from the argument by combining all
 states with identical classical information into a single one.
 \\nMany functions creating qcstates will call this internally
 so you should normally never get a qcstate where several members
 of the states list have identical classical information.
 \\nSee also: qcState, properQcstateQ
 ";
)

(
 "qmatrix`forget" ~usage~ "
 forget[ qcstate[ states_ ], pointer_ ] returns the given
 qcstate, with all classical knowledge about the given pointer
 discarded.
 \\nforget[ qcstate[ states_ ], pointers_List ] discards all
 pointers in the given list.
 \\nIn a sense, this function is the classical analogon of the
 quantum mechanical contract[].
 \\nDiscarding some knowledge will usually leave several
 members of the list states with identical (or even none at all)
 classical knowledge; such states will be combined into a single
 one.
 \\nThus, measuring and forgetting the result can be used to
 produce decoherence.
 \\nSee also: qcstate, measure
 ";
)

(
 "qmatrix`map" ~usage~ "
 An object of the form map[ op1_, op2_, ... ] represents a
 superoperator. The opi are understood as Kraus operators,
 acting on matrices in the usual way:
 \\n  map[ op1, op2,... ] ** matrix
 \\n     = op1**matrix**hc[op1] + op2**matrix**hc[op2] + ...
 \\nmaps can also be applied to qcstates, and can be multiplied
 with other maps.
 \\nThe operators should fulfill the condition
 \\n  Sum[ hc[opi] ** opi, {i,1,n} ] == identity
 \\nbut this constraint is not enforced.
 ";
)

(
 "qmatrix`condmap" ~usage~ "
 condmap[ { { map1_, cond1_}, { map2_, cond2 },... } ] represents
 a conditional map.
 The mapi are maps and the condi are boolean expressions.
 \\ncondmap[{{map1,cond1},...}] ** qcstate[states_List] will
 apply to each member of the list states the first map whose
 condition is satisfied by the classical knowledge.
 \\nA typical condition cond is pointer == value, where pointer
 is some pointer occuring in the classical knowledge of the qcstate,
 and value is some eigenvalue of the measurement from which the
 classical knowledge originated.
 \\nconditional maps can be useful to implement protocols like
 quantum teleportation; see teleportation.nb for a typical use
 of this object.
 \\nSee also: measure, map
 ";
)

(
 "qmatrix`randomRealVector" ~usage~ "
 randomRealVector[ n_Integer ] returns a List of n real coordinates
 representing in a orthonormal basis a normalized vector drawn from an
 equally distributed ensemble in a n-dimensional real vector space.
 \\nEqually distributed means that the ensemble is invariant under
 arbitrary orthogonal transforms.
 \\nSee also: randomComplexVector, randomKet.
 ";
)

(
 "qmatrix`randomComplexVector" ~usage~ "
 randomComplexVector[ n_Integer ] returns a List of n complex coordinates
 representing in a orthonormal basis a normalized vector drawn from an
 equally distributed ensemble in a n-dimensional complex vector space.
 \\nEqually distributed means that the ensemble is invariant under
 arbitrary unitary transforms.
 \\nSee also: randomRealVector, randomKet.
 ";
)

(
 "qmatrix`randomKet" ~usage~ "
 randomKet[ space__ ] returns a matrix representing in a orthonormal
 basis a normalized Ket drawn from an equally distributed ensemble in
 space. space can be any combination of modes and subsystems (ie, lists
 of modes).
 \\nEqually distributed means that the ensemble is invariant under
 arbitrary unitary transforms.
 \\nSee also: randomComplexVector.
 ";
)

(
 "qmatrix`compareWithPermutation" ~usage~ "
 compareWithPermutation[ target_List, source_List ] tries to find a
 permutation to transform source into target. Both source and
 target must be lists.
 \\nIf such a permutation exists, {True,<permutation>} is returned,
 or {False,{}} otherwise.
 \\nIf parts of source and target are not unique, several permutations
 may be possible, and one of them will be returned.
 \\nExample:
 \\n    i[169] compareWithPermutation[ {d,a,c,b}, {a,b,c,d} ]
 \\n    o[169] {True, {2, 4, 3, 1}}
 \\nThe result is a `moveto' recipe: move element from position 1
 into position 2, from position 2 into 4, and so on.
 \\nSee also: equalUpToPermutation, permute, signedPermutations
 ";
)

(
 "qmatrix`equalUpToPermutation" ~usage~ "
 equalUpToPermutation[ x_List, y_List ] checks whether there exists a
 permutation converting list y into list x. This function calls
 compareWithPermutation and returns either True or False.
 \\nSee also: compareWithPermutation, permute, signedPermutations
 ";
)

(
 "qmatrix`inversePermutation" ~usage~ "
 inversePermutation[ perm_List ] returns the inverse of perm,
 which must be a permutation of integers 1,...,n.
 \\nSee also: permute
 ";
)

(
 "qmatrix`permute" ~usage~ "
 qmatrix`permute[ list_List, perm_List ] returnes list permuted by perm:
 the element at position j in list will occur at position
 perm[[j]] in the list returned by this function.
 perm must be a permutation of the integers
 1,...,Length[list].
 \\nSee also: insersePermutation, compareWithPermutation, signedPermutations";
)

(
 "qmatrix`signedPermutations" ~usage~ "
 permutation`signedPermutations[ list_List ] returns a list of pairs, where the first
 element of any pair is a permutation of list, and the second element
 the sign of this permutation.
 \\nEvery possible permutation will occur exactly once.
 \\nAll list elements are treated as distinguishable; if they are
 not, several identical permutations will be returned, and the
 sign of a permutation is not well defined.
 \\nSee also: permute, inversePermutation, compareWithPermutation
 ";
)

(
 "Global`preList" ~usage~ "
 Global`preList is the only Global` symbol defined in the matrix
 package. This symbol is inherently Global` as it allows different
 packages to use the $Pre mechanism simultaneously in a transparent
 way without collisions.
 \\nGlobal`preList is a list. Every element of the list is either
 a function, or a pair comprising a function and an arbitrary
 identification cookie. All functions in the list are concatenated
 and applied to every input before evaluation. The cookie can be
 used to find functions in order to remove them from the list.
 \\nAll functions on the list must have the attribute HoldAll, or
 else they will not really be evaluated before the input, defying
 the purpose of $Pre as opposed to $Post.
 \\nThe qmatrix package uses this mechanism to undo temporary changes
 of the PageWidth (this only affects non-notebook interfaces).
 \\nSee also: context, $Pre
 ";
)

(
 Unprotect[
 qmatrix`matrix, qmatrix`fm
 , qmatrix`op
 , qmatrix`fermionic, qmatrix`bosonic, qmatrix`discrete
 , qmatrix`fixedAngularMomentum, qmatrix`basis, qmatrix`permutation
 , qmatrix`a, qmatrix`ad, qmatrix`id
 , qmatrix`jPlus, qmatrix`jMinus, qmatrix`jx, qmatrix`jy, qmatrix`jz
 , qmatrix`qcstate, qmatrix`map, qmatrix`condmap
 ] ;
)

(
 epsilon = N[10*^-12]
)

(
 setSystem[ sys_List ] := (
 Unprotect[ "qmatrix`system" ]
 ; qmatrix`system = sys
 ; Protect[ "qmatrix`system" ]
 ; qmatrix`system
 )
)

(
 setSystem[ x_, y___ ] := setSystem[ { x, y } ]
)

(
 setModeType[ mode_, type_ ] := (
 Unprotect[ "qmatrix`modeType" ]
 ; ( ( qmatrix`modeType[#] = type ) & /@ { #1, ket[#1], bra[#1] } )
   & [ mode // dequalify ]
 ; Protect[ mode, "qmatrix`modeType" ]
 ; modeType[mode]
 )
)

(
 specialObjects = {
 qmatrix`matrix, qmatrix`fm, qmatrix`op, qmatrix`map
 , qmatrix`qcstate, qmatrix`condmap
 , qmatrix`ket, qmatrix`bra
 };
)

(
 matrixQ[ x_ ] := x ~MatchQ~ matrix[ _, List[ (ket|bra)[_]... ] ]
)

(
 flatMatrixQ[ x_ ] := x ~MatchQ~ fm[ _, List[ (ket|bra)[_]... ] ]
)

(
 operatorQ[ x_ ] := x ~MatchQ~ op[ _, _, ___ ]
)

(
 modeQ[ m_ ] := MemberQ[ Flatten[system], m // dequalify ]
)

(
 qualifiedModeQ[ m_ ] := ( m ~MatchQ~ (ket|bra)[_] ) && modeQ[ m ]
)

(
 mustQualify[ m_ ] := qualifiedModeQ[ m ] || throw[
 "mustQualify", ": not a qualified mode (needs ket or bra wrapper): ", m
]
)

(
 dequalify[ x_ ] := x
)

(
 dequalify[ (ket|bra)[x_] ] := x
)

(
 SetAttributes[ dequalify, Listable ]
)

(
 qubitQ[ mode_ ] /; modeQ[ mode ] := dimension[ mode ] == 2
)

(
 modeIndex[ x_ ] /; modeQ[x]
    := # & @@ # & @@ Position[ Flatten[system], x // dequalify ]
)

(
 dimension[ x_ ] /; modeQ[x] := Switch[ modeType[x]
 , fermionic, 2
 , { bosonic, d_ }, #2 & @@ modeType[x]
 , { discrete, d_ }, #2 & @@ modeType[x]
 , { fixedAngularMomentum, j_ }, 1 + 2*#2 & @@ modeType[x]
 , _ , throw[ "dimension", ": undefined mode type: ", x, modeType[x] ]
 ]
)

(
 dimension[ list_List ] := Times @@ ( dimension /@ list )
)

(
 dimension[ (matrix|fm)[ c_, m_List ] ] := dimension[ m ]
)

(
 subSystem[ sys_, level_ ] :=
 ( Length[ # ] == 1
   || throw[ "subSystem", ": no or no unique Position: ", sys, system ] )
 && (
 ( Length[ # ] >= level
   || throw[ "subSystem", ": level higher than Position: ", level, # ] )
 && ( Part[ system, ## ] & ) @@ Take[ #, level ] & @@ #
 ) & [ Position[ system, sys ] ]
)

(
 modesValidQ[ (matrix|fm)[ c_, m_List ] ] := And @@ ( modeQ @@ #1 & /@ m )
)

(
 properMatrixQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    And @@ ( qualifiedModeQ /@ m )
  && And @@ ( Count[ m, # ] == 1 & /@ m )
  && Not[ MatchQ[ m, { ___, bra[x_], ___, ket[x_] , ___ } ] ]
)

(
 operatorMatrixQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    properMatrixQ[ matrix[ c, m ] ]
  && And @@ ( Count[ m, # // hc ] == 1 & /@ m )
)

(
 hermitianQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    properMatrixQ[ matrix[ c, m ] ]
  && matrix[ c, m ] // # == hc[#] &
)

(
 positiveQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    operatorMatrixQ[ matrix[ c, m ] ]
  && And @@ ( # ~GreaterEqual~ 0 & /@ eigenvalues[ matrix[ c, m ] ] )
)

(
 densityMatrixQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := positiveQ[ matrix[ c, m ] ] && trace[ matrix[ c, m ] ] == 1
)

(
 ketQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    properMatrixQ[ matrix[ c, m ] ]
  && And @@ ( MatchQ[ #, ket[_] ] && Count[ m, # ] == 1 & /@ m )
)

(
 braQ[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 :=    properMatrixQ[ matrix[ c, m ] ]
  && And @@ ( MatchQ[ #, bra[_] ] && Count[ m, # ] == 1 & /@ m )
)

(
 matrix[ c1_, m1_List ] == matrix[ c2_, m2_List ]
 /;  And @@ properMatrixQ /@ { matrix[ c1, m1 ], matrix[ c2, m2 ] }
 ^:= (
 #1 && (
   FullSimplify /@ And @@ (
     If[ NumberQ[ # ], Abs[#] < epsilon, # == 0 ] &
       /@ Flatten[ c1 - c2 ~Transpose~ #2 ]
   )
 ) & @@ compareWithPermutation[ m1, m2 ]
 )
)

(
 reorderMatrix[ matrix[ c_, m_List ], neworder_List ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := matrix[
 If[ #1
 , c ~Transpose~ #2
 , throw[ "reorderMatrix", ": no permutation found: ", m, neworder ]
 ] & @@ compareWithPermutation[ neworder, m ]
 , neworder
 ]
)

(
 partialTranspose[ matrix[ c_, m_List ], mode_ ]
 /; properMatrixQ[ matrix[ c, m ] ] && modeQ[ mode ]
 := matrix[
 Transpose[
   c
 , Range[ Length[ m ] ] /. { #1 :> #2 , #2 :> #1 }
   & @@ (
     ( Length[#1] != 1 || Length[#2] != 1 )
       && throw[ "partialTranspose", ": illegal number of occurences: ", m, mode ]
   ; Flatten[ { #1, #2 } ]
   ) & @@ ( Position[ m, #1 ] & /@ { bra[mode], ket[mode] } )
 ]
 , m
 ]
)

(
 partialTranspose[ matrix[ c_, m_ ], {} ] := matrix[ c, m ]
)

(
 partialTranspose[ matrix[ c_, m_ ], { mode_, lm___ } ]
 := partialTranspose[
 partialTranspose[ matrix[ c, m ] , mode ], {lm}
 ]
)

(
 hc[ matrix[ c_, m_List ] ] := If[
 m == {}
 , matrix[ Conjugate[c], m ]
 , matrix @@
 { Conjugate[ Transpose[ c, #1 ] ], #2 } & @@ Reverse /@ Transpose[
   MapIndexed[ { #1 & @@ #2 , #1 }& , hc /@ m ]
 ]
 ]
)

(
 hc[ ket[x_] ] := bra[x]
)

(
 hc[ bra[x_] ] := ket[x]
)

(
 hc[ l_List ] := Reverse[ hc /@ l ]
)

(
 hc[ x_ ] /; NumberQ[ x ] := Conjugate[x]
)

(
 hc[ NonCommutativeMultiply[ x___ ] ] :=
 NonCommutativeMultiply @@ hc[ { x } ]
)

(

 permuteBasis[ matrix[ c_, m_List ], qmode_, perm_List ]
 /; validModesQ[ matrix[ c, m ] ] && modeQ[ qmode ]
 := If[ Length[ # ] != 1
 , throw[ "permute", ": illegal number of occurrences: ", matrix[ c, m ], qmode ]
 , matrix[ Map[ # ~permute~ perm & , c , # - 1 & /@ # ] , m ]
 ] & [ Flatten[ Position[ m, qmode ] ] ]
)

(
 warpOperatorMatrix[ matrix[ c_, m_List ], newspace_List ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := If[
 Not[ operatorMatrixQ[ matrix[ c, m ] ] ]
 , throw[ "warpOperatorMatrix", ": not an operator matrix: ", matrix[ c, m ] ]
 , reorderMatrix[
   matrix[ c, m ] ~outerMatrixProduct~
     identityMatrix[ #1 ~Select~ ( ! MemberQ[ m, # ] & ) ]
 , #
 ] & [
   Flatten[
     { ket[#], bra[#] } & /@ Union[
       dequalify /@ Flatten[ newspace ]
     ]
   ]
 ]
 ]
)

(

 matrixPlus[ matrix[ c1_, m1_List ] , matrix[ c2_, m2_List ] ]
 /; properMatrixQ[ matrix[ c1, m1 ] ] && properMatrixQ[ matrix[ c2, m2 ] ]
 := (
 If[ And @@ ( operatorMatrixQ[ #1 ] & /@ { matrix[ c1, m1 ], matrix[ c2, m2 ] } )
 ,   matrix[ ( #1 & @@ #1 ) + ( #1 & @@ #2 ) , #2 & @@ #1 ] & @@ (
       m1 ~Join~ Select[ m2, Not[ MemberQ[ m1, #1  ] ] & ] // {
         warpOperatorMatrix[ matrix[ c1, m1 ] , # ]
       , warpOperatorMatrix[ matrix[ c2, m2 ] , # ]
       } &
     )
 , compareWithPermutation[ m1, m2 ] // If[ #1 & @@ #1
   , matrix[ c1 + Transpose[ c2, #2 & @@ #1 ] , m1 ]
   , throw[ "matrixPlus", ": can't match Hilbert spaces: ", m1, m2 ]
   ] &
 ]
 )
)

(
 matrixPlus[ a_, b_, var__ ] := matrixPlus[ matrixPlus[ a, b ], var ]
)

(
 matrixPlus[] := matrix[ 0, {} ]
)

(
 matrixPlus[ matrix[ c_, m_List ] ] := matrix[ c, m ]
)

(
 matrix[ c1_, m1_List ] + matrix[ c2_, m2_List ] ^:=
 matrix[ c1, m1 ] ~matrixPlus~ matrix[ c2, m2 ]
)

(
 commutator[ matrix[c1_,m1_], matrix[c2_,m2_] ]
 ^:= matrix[c1,m1] ** matrix[c2,m2] - matrix[c2,m2] ** matrix[c1,m1]
)

(
 contract[ matrix[ c_, m_List ], r_Integer, s_Integer ]
 := matrix[
 ( Apply[
   Plus @@ MapIndexed[ #1 [[ First[ #2 ] ]] & , { ## } , { s - r } ] &
 , c
 , { r - 1 }
 ] // FullSimplify )
 , m ~Delete~ s ~Delete~ r
 ]
)

(
 contractAll[ matrix[ c_, m_List ] ]
 /; And @@ ( MatchQ[ #1, (ket | bra)[_] ] && modeQ @@ #1 & /@ m )
 := If[
 Length[ #1 ] == 0
 , matrix[ c, m ]
 , matrix[
   ( Plus @@ Flatten [
     MapIndexed[ Fold[ Part, #1, #2 ] & , #1 , { #3 / 2 } ]
   , #3 / 2 - 1
   ] // FullSimplify )
 , #2
 ] & @@ {
   c ~Transpose~ inversePermutation[ #2 ~Join~ #1 ]
 , m [[ #1 ]] & /@ #1
 , Length[ #2 ]
 } & @@ {
   Fold[ DeleteCases, MapIndexed[ #1 & @@ #2 &, m ], #1 ]
 , #1
 } & [ Join @@ Transpose[ #1 ] ]
 ] & [
 { #2 & @@ Last[ #2 ] , #1 } & @@ #1 & /@ Select[
   { #2
   , Cases[
       MapIndexed[ { #1 , #1 & @@ #2 } &, m ~Take~ (#2-1) ]
     , { _ @@ #1, _ }
     ]
   } & @@ #1 & /@
   Cases[ MapIndexed[ { #1, #1 & @@ #2 } &, m ], { ket[_], _ } ]
 , Length[ #2 ] > 0 && MatchQ[ #1 & @@ Last[#2], bra[_] ] & @@ #1 &
 ]
 ]
)

(
 SetAttributes[ contractAll, Listable ]
)

(
 contract[ matrix[ c_, m_List ], mode_ ]
 /; modeQ[ mode ] && modesValidQ[ matrix[ c, m ] ]
 := contract @@ Flatten[
 {
   { matrix[ c, m ] }
 , Switch[ { Length[ #1 ], Length[ #2 ] }
   , { 0, 0 } , {{ }}
   , { 1, 1 } , Sort[ Flatten[ { #1 , #2 } ] ]
   , _ , throw[
       "contract", ": illegal number of occurences: "
     , matrix[ c, m ] , mode
      ]
   ] & @@
     ( Flatten[ Position[ m, #[ mode //dequalify ], 1 ] ] & /@ { bra , ket } )
 }
 , 1
 ]
)

(
 contract[ matrix[ c_, m_List ] , mode_ , moremodes__ ]
 := contract[
 contract[ matrix[ c, m ], mode ] , moremodes
 ]
)

(
 contract[ matrix[ c_, m_List ] , { whatever__ } ]
 := contract[ matrix[ c, m ], whatever ]
)

(
 contract[ matrix[ c_, m_List ] , { } ]  :=  matrix[ c, m ]
)

(
 contract[ matrix[ c_, m_List ] , Not[ space___ ] , whatever___ ]
 /; And @@ ( modeQ /@ Flatten[ { space } ] )
 := contract[
 matrix[ c, m ]
 , Select[
   # & @@ # & /@ m
 , Not[ MemberQ[ dequalify /@ Flatten[ { space } ] , # ] ] &
 ] // Union
 , whatever
 ]
)

(
 trace[ matrix[ c_, m_List ] ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := (
 operatorMatrixQ[ matrix[ c, m ] ]
   || throw[ "trace", ": not an operator matrix: ", matrix[ c, m ] ]
 ; #1 & @@ matrix[ c, m ] ~contract~ Union[ # & @@ # & /@ m ]
 )
)

(
 SetAttributes[ trace, Listable ]
)

(
 projectorOrthonormal[ matrix[ c_, m_List ] ]
 := #1 ~outerMatrixProduct~ hc[ #1 ] & [ matrix[ c, m ] ]
)

(
 projector[ list_List ]
 /; And @@ ( properMatrixQ[ #1 ] & /@ list )
 := Plus @@ ( projectorOrthonormal /@ gramSchmidt[
   If[ ketQ[#1], #1, If[ braQ[#1], hc[#1]
   , throw[ "projector", ": neither ket nor bra:", #1 ]
   ]] & /@ list
 ]
 )
)

(
 projector[ matrix[ c_, m_List ] ] := projector[ { matrix[ c, m ] } ]
)

(
 outerMatrixProduct[ matrix[ c1_, m1_List ] , matrix[ c2_, m2_List ] ]
 :=  matrix[ Outer[ Times, c1, c2 ] ,  m1 ~Join~ m2 ]
)

(
 outerMatrixProduct[ a_, b_, var__ ] := outerMatrixProduct[ outerMatrixProduct[ a, b ], var ]
)

(
 outerMatrixProduct[ matrix[ c_, m_ ] ] := matrix[ c, m ]
)

(
 outerMatrixProduct[ ] := matrix[ 1, {} ]
)

(

 diracMatrixProduct[ matrix[ c1_, m1_List ], matrix[ c2_, m2_List ] ]
 /; And @@ properMatrixQ /@ { matrix[ c1, m1 ], matrix[ c2, m2 ] }
 := If[ Length[#1] == 0
 , outerMatrixProduct[ matrix[ c1, m1 ], matrix[ c2, m2 ] ]
 , matrix @@ {
     ( Plus @@ Flatten[
       MapThread[
         If[ #5 , #1 * #2 & , Outer[ Times, #1 , #2 ] & ]
       , { #2 , #3 } , #1
       ]
     , #1 - 1
     ] // FullSimplify )
   , #4
   } & @@ {
     #1
   , #1 & @@ matrix[ c1, m1 ] ~reorderMatrix~ #2
   , #1 & @@ matrix[ c2, m2 ] ~reorderMatrix~ #3
   , #4
   , #5
   } & @@ {
     #1
   , #2 ~Join~ #4
   , #3 ~Join~ #5
   , #4 ~Join~ #5
   , #4 == {} || #5 == {}
   } & @@ {
     #1 // Length
   , #2
   , #3
   , Fold[ DeleteCases, m1, #2 ]
   , Fold[ DeleteCases, m2, #3 ]
   } & @@ Transpose[ #1 ]
 ] & [
   ( { Length[ Position[ m1, #1 ] ], #1, #2 } & @@ # & /@ (
     { bra @@ #, # } & /@ Cases[ m2 , ket[_] ] ) )
   ~Select~ ( # > 0 & @@ # & )
 ]
)

(
 matrix[ c1_, m1_List ] ** matrix[ c2_, m2_List ]
 ^:= Switch[ { Length[m1], Length[m2] }
 , { 0, _ } , c1 * matrix[ c2, m2 ]
 , { _, 0 } , c2 * matrix[ c1, m1 ]
 , _        , matrix[ c1, m1 ] ~diracMatrixProduct~ matrix[ c2, m2 ]
 ]
)

(
 diracMatrixProduct[ matrix[ c_, m_List ] ] ^:= matrix[ c, m ]
)

(
 diracMatrixProduct[] := matrix[ 1, {} ]
)

(
 Unprotect[ NonCommutativeMultiply ]
; 0 ** matrix[ c_, m_List ] := nullMatrix[ m ]
; matrix[ c_, m_List ] ** 0 := nullMatrix[ m ]
; Protect[ NonCommutativeMultiply ]
)

(
 x_ * matrix[ c_, m_List ] ^:= matrix[ x * c , m ]
)

(

 normalize[ matrix[ c_, m_List ] ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := If[
 operatorMatrixQ[ matrix[ c, m ] ]
 ,  matrix[ c, m ] / trace[ matrix[ c, m ] ]
 , If[
   ketQ[ matrix[ c, m ] ]
 , matrix[ c, m ] / Sqrt[ trace[ hc[ matrix[ c, m ] ] ** matrix[ c, m ] ] ]
 , If[
     braQ[ matrix[ c, m ] ]
   , matrix[ c, m ] / Sqrt[ trace[ matrix[ c, m ] ** hc[ matrix[ c, m ] ] ] ]
   , throw[ "normalize", ": can't normalize (neither ket nor bra nor operator): ", matrix[ c, m ] ]
   ]
 ]
 ]
)

(
 SetAttributes[ normalize, Listable ]
)

(
 normSquare[ matrix[ c_, m_ ] ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := If[ ketQ[ #1 ], trace[ hc[#1] ** #1 ] // Re
 , If[ braQ[ #1 ], trace[ #1 ** hc[#1] ] // Re
 , throw[ "normSquare", ": neither ket nor bra: ", #1 ]
 ]
 ] & [ matrix[ c, m ] ]
)

(
 norm[ matrix[ c_, m_ ] ] := Sqrt[ normSquare[ matrix[ c, m ] ] ]
)

(
 inverse[ matrix[ c_, m_List ] ]
 /; operatorMatrixQ[ matrix[ c, m ] ]
 := If[ m == {}
 , matrix[ 1/c, m ]
 , nestify[ fm[ Inverse[ #1 ], #2 ] ] & @@ flatten[ matrix[ c, m ] ]
 ]
)

(
 SetAttributes[ inverse, Listable ]
)

(
 gramSchmidt$rec[ vlist_List ] := If[ vlist == {} , {}
 , #1 ~Join~ ( If[ norm[#1] > epsilon, { #1 // normalize }, {}
 , throw[ "gramSchmidt", ": cannot determine norm: ", #1, norm[#1] ]
 ] & [
   Last[vlist] - ( matrixPlus @@ ( projectorOrthonormal /@ #1 ) ) ** Last[vlist]
 ] ) & [ gramSchmidt$rec[ vlist ~Drop~ -1 ] ]
 ]
)

(
 gramSchmidt[ vlist_List ]
 /; And @@ ( ModeQ /@ vlist )
 := If[ And @@ ( ketQ /@ vlist ), gramSchmidt$rec[ vlist ]
 , throw[ "gramSchmidt", ": not a list of kets: ", vlist ]
 ]
)

(
 schmidtDecomposition[ matrix[ c_, m_List ], space_ ]
 /; modesValidQ[ matrix[ c, m ] ]
 := (
 ketQ[ matrix[ c, m ] ] || throw[
   "schmidtDecomposition", ": not a Ket: ", matrix[ c, m ]
 ]
 ; { hc[#1] ** matrix[ c, m ], #1, #2 } & @@ #1 & /@ normalizedEigensystem[
   If[ #1 ~MatchQ~ matrix[_,_], #1
   , throw[ "schmidtDecomposition", ": contract failed for ", space ]
   ] & [ ( #1 ** hc[#1] & [ matrix[ c, m ] ] ) ~contract~ space ]
 ]
 )
)

(
 schmidtRank[ matrix[ c_, m_List ], space_ ]
/; modesValidQ[ matrix[ c, m ] ]
:= schmidtDecomposition[ matrix[ c, m ], space ]
  ~Select~ ( Abs[ #3 & @@ #1 ] > epsilon & ) // Length
)

(
 flatten[ matrix[ c_, m_ ] ] /; properMatrixQ[ matrix[ c, m ] ] :=
 If[ m == {}
 , fm[ c, m ]
 , fm[
   If[
     Length[ #1 ] >= 0
   , Flatten[ { #2 }, Length[ #1 ] ]
   , #2
   ] & @@ {
     #1
   , If[
       Length[ #2 ] > 0
     , Map[ Flatten, #3, { Length[ #1 ] } ]
     , #3
     ]
   }
 , #1 ~Join~ #2
 ] & @@ {
   #1
 , #2
 , c ~Transpose~ #2 & @@ compareWithPermutation[ #1 ~Join~ #2, m ]
 } & @@ {
   #1
 , If[ operatorMatrixQ[ matrix[ c, m ] ]
   , bra @@ #1 & /@ #1
   , Cases[ m, bra[_] ]
   ]
 } & [ Cases[ m, ket[_] ] ]
 ]
)

(
 SetAttributes[ flatten, Listable ]
)

(
 nestify$rec[ c_, m_List ] := If[
 Length[ m ] > 1
 , nestify$rec[ #, m ~Drop~ -1 ] &
 , # &
 ] [ Partition[ c, dimension @@ Last[ m ] ] ]
)

(
 nestify[ fm[ c_, m_List ] ]
 /; modesValidQ[ fm[ c, m ] ]
 := If[ Length[ m ] > 0
 , matrix[ Flatten[ nestify$rec[ Flatten[c], m ], 1 ] , m ]
 , matrix[ c, { } ]
 ]
)

(
 SetAttributes[ nestify, Listable ]
)

(
 pageWidthIsSpecial = False
)

(
 normalPageWidth = ( #2 & @@ #1 & @@ Select[Options[$Output], !FreeQ[#1, PageWidth] & ] )
)

(
 postformat[ x_ ] := x
)

(
 postformat[ l_List ] := postformat /@ l
)

(

 prefunction[ x_ ] := (
 If[ pageWidthIsSpecial
 ,   SetOptions[ $Output, PageWidth->normalPageWidth ]
   ; Unprotect[ pageWidthIsSpecial ]
   ; pageWidthIsSpecial = False
   ; Protect[ pageWidthIsSpecial ]
 ]
 ; postformat[ x ]
 )
)

(
 SetAttributes[ prefunction, HoldAll ]
)

(
 Unprotect[ $Pre, Global`preList ]
)

(
 ListQ[ Global`preList ] || ( Global`preList = {} )
)

(
 $Pre := Function[
 x
 , x // Composition @@ (
   If[ ListQ[ #1 ], #1 & @@ #1, #1 ] & /@ Global`preList
 )
 , HoldAll
 ]
)

(
 Protect[ $Pre, Global`preList ]
)

(

(* ;; PageWidth only seems to affect non-notebook interfaces; we avoid *)
(* ;; any risk of confusing the pointy-clicky-drooly brigade: *)
 $Notebooks || (
 Global`preList ~Cases~ { _, { "matrix", "prefunction" } } == {} && (
   Unprotect[ Global`preList ]
 ; Global`preList = Global`preList ~Append~ {
     prefunction, { "matrix", "prefunction" }
   }
 ; Protect[ Global`preList ]
 )
 )
)

(
 setTemporaryPageWidth[ pageWidth_Integer ] := If[ $Notebooks
 ,   Null
 ,   If[ pageWidthIsSpecial
   ,
   ,   Unprotect[ normalPageWidth ]
     ; normalPageWidth = ( #2 & @@ #1 & @@ Select[Options[$Output], !FreeQ[#1, PageWidth] & ] )
     ; Protect[ normalPageWidth ]
   ]
 ; SetOptions[ $Output, PageWidth->pageWidth ]
 ; Unprotect[ pageWidthIsSpecial ]
 ; pageWidthIsSpecial = True
 ; Protect[ pageWidthIsSpecial ]
 ]
)

(
 pretty[ matrix[ c_, m_List ], pagewidth_Integer:2^15 ]
 := If[ #1 ~MatchQ~ fm[_,_], #1 ~pretty~ pagewidth, #1 ]
   & [ flatten[ matrix[ c, m ] ] ]
)

(
 Format[ matrix[ c_, m_List ]
 /; properMatrixQ[ matrix[ c, m ] ] ]
 := pretty[ matrix[ c, m ], 0 ]
)

(
 Attributes[ pretty ] = { Listable };
)

(
 postformat[ matrix[ c_List, m_List ] ]
 /; properMatrixQ[ matrix[ c, m ] ]
 := (
 setTemporaryPageWidth[ 2^15 ]
 ; matrix[ c, m ]
 )
)

(
 pretty[ fm[ c_, m_List ], pagewidth_Integer:0 ] :=  (
 # != 0 && setTemporaryPageWidth[ # ] & [ pagewidth ]
 ; { c // FullSimplify // N // MatrixForm
 , m
 } // ColumnForm
 )
)

(
 Format[ fm[ c_, m_ ] ] := pretty[ fm[ c, m ] ]
)

(
 postformat[ fm[ c_, m_ ] ] := (
 setTemporaryPageWidth[ 2^15 ]
 ; fm[ c, m ]
 )
)

(
 TeXForm[ matrix[ c_, m_List ] ]
 ^:= If[ #1 ~MatchQ~ fm[_,_], TeXForm[ #1 ]
 , throw[ "TeXForm", ": cannot convert to MatrixForm" ]
 ] & [ matrix[ c, m ] // flatten ]
)

(
 TeXForm[ fm[ c_, m_List ] ] ^:= TeXForm[ MatrixForm[ c ] ]
)

(
 eigensystem[ fm[ c_, m_List ] ]
 /; modesValidQ[ fm[ c, m ] ]
 := If[ m == {}
 , { { fm[ 1, {} ], c } }
 , If[
   ( #1 ~Mod~ 2 != 0
     || Not[ And @@ ( MatchQ[ #, ket[_] ] & /@ Take[ m, #1 / 2 ] ) ]
     || Take[ m, -#1 / 2 ] =!= ( bra @@ # & /@ Take[ m, #1 / 2 ] )
   ) & [ Length[ m ] ]
 , throw[ "eigensystem", ": not a flat square matrix: ", fm[ c, m ] ]
 , { fm[ #2 , Cases[ m, ket[_] ] ], #1 } & @@ #1 & /@ Transpose[ Eigensystem[ c ] ]
 ]
 ]
)

(
 eigensystem[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := { nestify[ #1 ] , #2 } & @@ # &
    /@ eigensystem[ flatten[ matrix[ c, m ] ] ]
)

(
 eigenvectors[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := Apply[ nestify[ # ] &, eigensystem[ flatten[ matrix[ c, m ] ] ] , 1 ]
)

(
 eigenvalues[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := Apply[ #2 &, eigensystem[ flatten[ matrix[ c, m ] ] ] , 1 ]
)

(
 normalizedEigensystem[ matrix[ c_, m_ ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := {
 nestify[
   fm[ #1 / Sqrt[ Plus @@ ( # * Conjugate[ # ] & /@ #1 ) ] , #2 ]
 ] & @@ #1
 , #2
 } & @@ # & /@ eigensystem[ flatten[ matrix[ c, m ] ] ]
)

(
 log[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := (
 If[ Not[ operatorMatrixQ[ matrix[ c, m ] ] ]
 , throw[ "log", ": not an operator matrix: ", matrix[ c, m ] ]
 ]
 ; If[ hermitianQ[ matrix[ c, m ] ]
 , Plus @@ (
     If[ #2 == 0, logOfNull, Log[ #2 ] ] * #1 ** hc[ #1 ] & @@ # &
       /@ normalizedEigensystem[ matrix[ c, m ] ]
   )
 , nestify[
     fm[
       Transpose[ #2 ]
       . DiagonalMatrix[ If[ # == 0, logOfNull, Log[#] ] & /@ #1 ]
       . Inverse[ Transpose[ #2 ] ]
       & @@ ( #1 //	Eigensystem )
     , #2
     ]
   ] & @@ flatten[ matrix[ c, m ] ]
 ]
 )
)

(
 ld[ matrix[ c_, m_List ] ] := log[ matrix[ c, m ] ] / Log[2]
)

(
 Log[ matrix[ c, m_List ] ] ^:= log[ matrix[ c, m ] ]
)

(
 exp[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := (
 If[ Not[ operatorMatrixQ[ matrix[ c, m ] ] ]
 , throw[ "exp", ": not an operatorr matrix: ", matrix[ c, m ] ]
 ]
 ; If[ hermitianQ[ matrix[ c, m ] ]
 , Plus @@ (
     Exp[ #2 ] * #1 ** hc[ #1 ] & @@ # & /@
       normalizedEigensystem[ matrix[ c, m ] ]
   )
 , nestify[
     fm[
       Transpose[ #2 ]
       . DiagonalMatrix[ Exp[#] & /@ #1 ]
       . Inverse[ Transpose[ #2 ] ]
       & @@ ( #1 //	Eigensystem )
     , #2
     ]
   ] & @@ flatten[ matrix[ c, m ] ]
 ]
 )
)

(
 Exp[ matrix[ c_, m_ ] ] ^:= exp[ matrix[ c, m ] ]
)

(
 sqrt[ matrix[ c_, m_List ] ]
 /; modesValidQ[ matrix[ c, m ] ]
 := (
 If[ Not[ operatorMatrixQ[ matrix[ c, m ] ] ]
 , throw[ "sqrt", ": not an operator matrix: ", matrix[ c, m ] ]
 ]
 ; If[ hermitianQ[ matrix[ c, m ] ]
 , Plus @@ (
     Sqrt[ #2 ] * #1 ** hc[ #1 ] & @@ # & /@
       normalizedEigensystem[ matrix[ c, m ] ]
   )
 , nestify[
     fm[
       Transpose[ #2 ]
       . DiagonalMatrix[ Sqrt[#1] & /@ #1 ]
       . Inverse[ Transpose[ #2 ] ]
       & @@ ( #1 // Eigensystem )
     , #2
     ]
   ] & @@ flatten[ matrix[ c, m ] ]
 ]
 )
)

(
 Sqrt[ matrix[ c_, m_ ] ] ^:= sqrt[ matrix[ c, m ] ]
)

(
 jzMax[ mode_ ] := (dimension[mode] - 1) / 2
)

(
 matrix[ op[ optype_, mode_, varargs___ ] ] /; modeQ[ mode ]
 ^:= matrix[
 Outer[
   Switch[ { optype, modeType[ mode ] }
   , { basis, _ }
     , Switch[ Length[ {varargs} ]
       , 1 , If[ varargs == #1 && varargs == #2, 1, 0 ]
       , 2 , If[ {varargs} == {#1,#2}, 1, 0 ]
       , _ , throw[
         "matrix[ operator ]", ": wrong number of arguments for basis state operator"
       , optype, mode
        ]
     ]
   , { permutation, _ }
     , Switch[ Length[ {varargs} ]
       , 1 , If[ #1 == varargs[[#2]], 1, 0 ]
       , _, throw[
         "matrix[ operator ]", ": wrong number of arguments for permutation operator"
       , optype, mode
        ]
     ]
   , { id, _ }
     , If[ #1 == #2, 1, 0 ]
   , { a, fermionic | { discrete, d_ } }
     , If[ #2 - #1 == 1 , 1, 0 ]
   , { ad, fermionic | { discrete, d_ } }
     , If[ #1 - #2 == 1 , 1, 0 ]
   , { a, { bosonic, d_ } }
     , If[ #2 - #1 == 1, Sqrt[#2-1], 0 ]
   , { ad, { bosonic, d_ } }
     , If[ #1 - #2 == 1, Sqrt[#1-1], 0 ]
   , { a, { fixedAngularMomentum, _ } } | { jMinus, _ }
     , If[ #2 - #1 == 1
       , Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 - 1 ) ] &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ]
   , { ad, { fixedAngularMomentum, _ } } | { jPlus, _ }
     , If[ #1 - #2 == 1
       , Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 + 1 ) ] &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ]
   , { jx, _ }
     , If[ #2 - #1 == 1
       , Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 - 1 ) ] / 2 &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ] + If[ #1 - #2 == 1
       , Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 + 1 ) ] / 2 &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ]
   , { jy, _ }
     , If[ #2 - #1 == 1
       , I Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 - 1 ) ] / 2 &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ] - If[ #1 - #2 == 1
       , I Sqrt[ #1 * ( #1 + 1 ) - #2 * ( #2 + 1 ) ] / 2 &
           @@ ( { #1, #2 - #1 } & [ jzMax[ mode ], #2 - 1 ] )
       , 0
       ]
   , { jz, _ }
     , If[ #1 == #2 , #2 - 1 - jzMax[ mode ], 0 ]
   , _ , throw[
           "matrix[ operator ]", ": conversion not (yet?) defined: "
         , optype, modeType[ mode ]
          ]
   ] &
 , Sequence @@ {#, #} & [ Range[ dimension[ mode ] ] ]
 ]
 , { ket[mode] , bra[mode] }
 ]
)

(
 stateSwapper[ m1_, m2_ ]
 /; modeQ[ m1 ] && modeQ[ m2 ] && dimension[ m1 ] == dimension[ m2 ]
 := matrixPlus @@ (
 matrix[ op[ basis, m1, #1 , #2 ] ] ** matrix[ op[ basis, m2, #2, #1 ] ]
 & @@ #1 & /@ (
   Outer[ List, #1, #1 ] & [ Range[ dimension[ m1 ] ] ]
    ~Flatten~ 1
 )
 )
)

(
 notGate[ mode_ ] /; qubitQ[ mode ]
 := matrix[ op[ basis, mode, 1, 2 ] ] + matrix[ op[ basis, mode, 2, 1 ] ]
)

(
 cnotGate[ qubit_, control_ ] /; ( qubitQ[ qubit ] && qubitQ[ control ] )
 :=   matrix[ op[ id, qubit ] ] ** matrix[ op[ basis, control, 1, 1 ] ]
  + notGate[ qubit ]          ** matrix[ op[ basis, control, 2, 2 ] ]
)

(
 fourierTransform[ mode_ ] /; modeQ[ mode ] := matrix[
 Apply[
   Exp[ - 2 * Pi * I * #1 ] &
 , Outer[ (#1-1) * (#2-1) / #3 & , #1, #1, {#2} ] & [ Range[ #1 ], #1 ]
 , { 2 }
 ] / Sqrt[ #1 ] & [ dimension[ mode ] ]
 , { ket[ mode ], bra[ mode ] }
 ]
)

(
 basisKet[ mode_, n_ ] /; modeQ[ mode ] := matrix[
 If[ n == #, 1, 0 ] & /@ Range[ dimension[ mode ] ]
 , { ket[ mode ] }
 ]
)

(
 basisBra[ n_, mode_ ] := hc[ basisKet[ n, mode ] ]
)

(
 nullMatrix[ m_List ] /; And @@ ( modeQ[ # //dequalify ] & /@ Flatten[ m ] )
 := (
 And @@ ( mustQualify /@ Flatten[ m ] )
 ; If[ m == {}
 , matrix[ 0, {} ]
 , matrix[
     Outer @@ ( { # & } ~Join~
                ( ( 0 & /@ ( Range[ dimension[#] ] ) & @@ # ) & /@ Flatten[ m ] ) )
   , m
   ]
 ]
 )
)

(
 nullMatrix[ m___ ] := nullMatrix[ { m } ]
)

(
 identityMatrix[ m_List ] /; And @@ ( modeQ[ # //dequalify ] & /@ Flatten[ m ] )
 := If[ m == {}
 , matrix[ 1, {} ]
 , matrix[
   Outer @@ (
     { Times } ~Join~ (
       Outer[ If[ #1==#2, 1, 0 ] &, #1, #1 ] &
           [ Range[ dimension[ # ] ] ] & /@ #
     )
   )
 , Flatten[ { ket[#], bra[#] } & /@ # ]
 ] & [ Union[ m //Flatten //dequalify ] ]
 ]
)

(
 identityMatrix[ m___ ] := identityMatrix[ { m } ]
)

(
 generalState[ mode_, name_ ] /; modeQ[ mode ] :=
 ( ( NumberQ[ # ] || ( # ^= 1 ) ) & [ trace[#] ] ; # ) & [
 matrix[
   Outer[
     ToExpression[ StringJoin @@ ( ToString /@ { name, #1, #2 } ) ] &
   , Sequence @@ {#, #} & [ Range[ dimension[ mode ] ] ]
   ]
 , { ket[ mode ], bra[ mode ] }
 ]
 ]
)

(
 generalKet[ mode_, name_ ] /; modeQ[ mode ] :=
 matrix[
   ToExpression[ StringJoin @@ ( ToString /@ { name, # } ) ] &
     /@ Range[ dimension[ mode ] ]
 , { ket[ mode ] }
 ]
)

(
 generalBra[ x___ ] := hc[ generalKet[ x ] ]
)

(
 generalPureState[ x___ ] := # ** hc[#] & [ generalKet[ x ] ]
)

(
 perfectMixture[ mode_ ] /; modeQ[ mode ] := matrix[
 Outer[
   If[ #1 == #2, 1, 0 ] &
 , Sequence @@ {#, #} & [ Range[ dimension[ mode ] ] ]
 ]
 , { ket[mode], bra[mode] }
 ]
)

(
 bellStateKet[ ma_, mb_, n_Integer:1 ] /; qubitQ[ ma ] && qubitQ[ mb ]
 := matrix[
 Outer[
   Switch[ { n, #1, #2 }
   , { 1, 1, 2 } ,   1 / Sqrt[2]
   , { 1, 2, 1 } , - 1 / Sqrt[2]
   , { 2, 1, 2 } ,   1 / Sqrt[2]
   , { 2, 2, 1 } ,   1 / Sqrt[2]
   , { 3, 1, 1 } ,   1 / Sqrt[2]
   , { 3, 2, 2 } , - 1 / Sqrt[2]
   , { 4, 1, 1 } ,   1 / Sqrt[2]
   , { 4, 2, 2 } ,   1 / Sqrt[2]
   , _ , 0
   ] &
 , { 1, 2 } , { 1, 2 }
 ]
 , { ket[ma], ket[mb] }
 ]
)

(
 singletKet[ ma_, mb_ ] := bellStateKet[ ma, mb, 1 ]
)

(
 bellState[ ma_, mb_, n_:1 ]
 := # ** hc[#] & [ bellStateKet[ ma, mb, n ] ]
)

(
 singlet[ ma_, mb_ ] := bellState[ ma, mb, 1 ]
)

(
 wernerState[ lambda_, m1_, m2_ ] := (
 lambda * perfectMixture[ m1 ] ** perfectMixture[ m2 ]
 + ( 1 - lambda ) * singlet[ m1, m2 ]
 )
)

(
 det[ matrix[ c_, m_List ] ] 	/; operatorMatrixQ[ matrix[ c, m ] ]
 := Det[ #1 & @@ flatten[ matrix[ c, m ] ] ]
)

(
 Det[ matrix[ c_, m_ ] ] ^:= det[ matrix[ c, m ] ]
)

(
 neumannEntropy[ matrix[ c_, m_ ] ] :=  - trace[
 matrix[ c, m ] ** (
   ld[ matrix[ c, m ] ] //. { m1_ ** logOfNull ** m2_ :> 0 }
 )
 ]
)

(
 relativeEntropy[ matrix[ cOf_, mOf_ ], matrix[ cTo_, mTo_ ] ] :=
 trace[
 matrix[ cOf, mOf ] ** (
   ld[ matrix[ cOf, mOf ] ] - ld[ matrix[ cTo, mTo ] ]
 )
 ]
)

(
 factorizes[ matrix[ c_, m_List ], space_ ]
 /; operatorMatrixQ[ matrix[ c, m ] ]
 := trace[ matrix[ c, m ] ] // If[ #1 == 0
 , throw[ "factorizes", ": sorry, operator is trace-free, cannot check: ", matrix[ c, m ] ]
 , # == ( # ~contract~ space ) **  ( # ~contract~ Not[ space ] ) &
   [ matrix[ c, m ] / # ]
 ] &
)

(
 factorizes[ matrix[ c_, m_List ], space_ ]
 /; ketQ[ matrix[ c, m ] ]
 := factorizes[ # ** hc[#] & [ matrix[ c, m ] ], space ]
)

(
 factorizes[ matrix[ c_, m_ ], space_ ]
 /; ketQ[ matrix[ c, m ] ]
 := factorizes[ hc[#] ** # & [ matrix[ c, m ] ], space ]
)

(
 qcstate[ matrix[ c_, m_List ] ] := qcstate[ { { matrix[ c, m ], {} } } ]
)

(
 measure[ matrix[ c_, m_List ], { mode_, pointer_, knowledge_List:{} } ]
 /; modeQ[ mode ] := (
   operatorMatrixQ[ matrix[ c, m ] ]
     || throw[ "measure", ": matrix must be a (state) operator: ", matrix[ c, m ] ]
 ; MemberQ[ m, ket[mode], 1 ]
     || throw[ "measure", ": state operator ", matrix[c,m], " does not live in mode ", mode ]
 ;
     qcstate[
       { #1, knowledge ~Join~ { pointer->#2 } } & @@ #1 & /@ (
         {    matrix[ op[ basis, mode, #1 ] ]
           ** matrix[ c, m ]
           ** matrix[ op[ basis, mode, #1 ] ]
         , #1
         } & /@ Range[ dimension[ mode ] ]
       )
     ]
 )
)

(
 measure[ matrix[ c_, m_List ], { obs_, pointer_, knowledge_List:{} } ]
 /; operatorMatrixQ[ obs ] := (
   operatorMatrixQ[ matrix[ c, m ] ]
     || throw[ "measure", ": matrix must be a (state) operator: ", matrix[ c, m ] ]
 ; And @@ ( MemberQ[ m, #, 1 ] & /@ obs[[2]] )
     || throw[ "measure", ": observable ", obs, " acts outside state space ", m ]
 ; collectIdenticalKnowledge[
     qcstate[
       { #1, knowledge ~Join~ { pointer->#2 } } & @@ #1 & /@ (
         { #1 ** hc[#1] ** matrix[ c, m ] ** #1 ** hc[ #1 ], #2 } &
           @@ # & /@ normalizedEigensystem[ obs ]
       )
     ]
   ]
 )
)

(
 measure[ qcstate[ states_List ], { what_ , pointer_, knowledge_List:{} } ] :=
 qcstate[
 Flatten[
   ( List @@ measure[ #1, { what, pointer, #2 ~Join~ knowledge } ] ) &
     @@ # & /@ states
 , 2
 ]
 ]
)

(
 contract[ qcstate[ states_List ], whatever__ ] :=
 qcstate[ { contract[ #1, whatever ], #2 } & @@ # & /@ states ]
)

(
 properQcstateQ[ qcstate[ states_List ] ] :=
 (
 And @@ ( MatchQ[ #1, { matrix[ _List, _List	], { (_->_) ... } } ]
           & /@ states )
 ) && (
 And @@ ( operatorMatrixQ[#1] & @@ #1 & /@ states )
 ) && (
 Plus @@ ( trace[ #1 ] & @@ #1 & /@ states ) == 1
 ) && (
 And @@ (
   ( #2 & @@ #1 & @@ #1 & @@ states )
     ~equalUpToPermutation~ #2 & @@ #1 & @@ #1 & /@ Rest[ states ]
 )
 )
)

(
 dimension[ qcstate[ states_List ] ]
 := dimension[ # & @@ # & @@ states ]
)

(
 qcstate[ s1_List ] == qcstate[ s2_List ]
 ^:= If[ #1
 , And @@ ( #1 == #2 & @@ # & /@
   Transpose[ { # & @@ # & /@ s1 , # & @@ # & /@ ( s2 ~permute~ #2 ) } ]
 )
 , False
 ] & @@
 compareWithPermutation[ #2 & @@ Transpose[ s1 ]
                       , #2 & @@ Transpose[ s2 ] ]
)

(
 reorderMatrix[ qcstate[ states_List ], neworder_ ]
 := qcstate[
 { #1 ~reorderMatrix~ neworder, #2 } & @@ # & /@ states
 ]
)

(
 collectIdenticalKnowledge[ qcstate[ states_List ] ] := qcstate[
 { FullSimplify[ Plus @@ # & @@ #2 ] , #1 } &
   @@ # & @@ # & /@
 Outer[
   { #1, Transpose[ states[[#1]] & /@ Flatten[ Position[ #2, #1, 1 ] ] ] } &
 , #1
 , { #2 }
 , 1
 ] & @@ { Union[ #1 ], #1 } & [ Sort[#2] & @@ #1 & /@ states ]
 ]
)

(
 forget[ qcstate[ states_List ], pointers_  ]
 := collectIdenticalKnowledge[
 qcstate[
   {
     #1
   , #2 ~DeleteCases~ If[ ListQ[ pointers ]
     , Alternatives @@ ( ( #1 -> _ ) & /@ pointers )
     , ( pointers->_ )
     ]
   } & @@ # & /@ states
 ]
 ]
)

(
 pretty[ qcstate[ states_List ], width_Integer:0 ] := ColumnForm[
 ColumnForm[ { #1 ~pretty~ width , #2, "p=" <> ToString[#1//trace//N], "============" } ]
   & @@ #1 & /@ states
 ]
)

(
 Format[ qcstate[ states_List ] ] := pretty[ qcstate[ states ] ]
)

(
 postformat[ qcstate[ states_List ] ] := (
 setTemporaryPageWidth[ 2^15 ]
 ; qcstate[ states ]
 )
)

(
 factorizes[ qcstate[ states_List ], space_ ] :=
 { #2 , #1 ~factorizes~ space } & @@ # & /@ states
)

(

 qcstate[ states_List ] ** matrix[ c, m_List ] ^:=
   qcstate[ { #1 ** matrix[ c, m ], #2 } & @@ # & /@ states ]
 ; matrix[ c, m_List ] ** qcstate[ states_List ] ^:=
   qcstate[ { matrix[ c, m ] ** #1, #2 } & @@ # & /@ states ]
 ; qcstate[ s1_List ] ** qcstate[ s2_List ] ^:= qcstate[
   Outer[
     (
       If[ #1 != {}
       , throw[ "qcstate ** qcstate", ": identical pointers in lhs and rhs while multiplying states: ", #1 ]
       ] & [ Intersection[ #1 & @@ #1 & /@ #1[[2]], #1 & @@ #1 & /@ #2[[2]] ] ]
     ; If[ #1 != {}
       , throw[ "qcstate ** qcstate", ": identical modes in lhs and rhs while multiplying states: ", #1 ]
       ] & [ Intersection[ #2 & @@ #1[[1]], #2 & @@ #2[[1]] ] ]
     ; { #1[[1]] ** #2[[1]], #1[[2]] ~Join~ #2[[2]] }
     ) &
   , s1, s2 , 1
   ] ~Flatten~ 1
 ]
)

(
 map[ ops_List ] ** matrix[ c_, m_List ] ^:= (
   Plus @@ (
     (
       Complement[ #1[[2]], m ] == {}
         || throw[ "map", ": operator ", #1, " acts outside state space ", m ]
     ; #1 ** matrix[ c, m ] ** hc[#1]
     ) & /@ ops
   )
 )
 ; map[ ops_List ] ** qcstate[ s_List ] ^:=
   qcstate[ { map[ops] ** #1, #2 } & @@ # & /@ s ]
 ; map[ left_List ] ** map[ right_List ] ^:=
   map[ Flatten[ Outer[ NonCommutativeMultiply, left, right, 1 ], 1 ] ]
)

(
 pretty[ map[ ops_List ], width_Integer:0 ] := ColumnForm[
 #1 ~pretty~ width & /@ ops
 ]
)

(
 Format[ map[ ops_List ] ] := pretty[ map[ ops ] ]
)

(
 postformat[ map[ ops_List ] ] := (
 setTemporaryPageWidth[ 2^15 ] ; map[ ops ]
 )
)

(
 condmap[ cmaps_List ] ** qcstate[ states_List ] ^:=
 qcstate[
 (
   #1 == {}
     && throw[ "condmap", ": no map for knowledge ", #3 ]
 ; { #1 & @@ First[#1] ** #2, #3 }
 ) & @@ #1 & /@
 (
   {
       (
         Flatten[ #1, 1 ] & /@
           Outer[
             { #1 & @@ #1, ( #2 & @@ #1 //. #2 ) } &
           , cmaps
           , { #2 }
           , 1
           ]
       ) ~Select~ ( #2 & @@ #1 & )
     , #1
     , #2
   } & @@ #1 & /@ states
 )
 ]
)

(
 pretty[ condmap[ cmaps_List ], width_Integer:2^15 ] := ColumnForm[
 ColumnForm[ {
   #2
 , #1 // pretty
 , "========================"
 } ] & @@ #1 & /@ cmaps
 ]
)

(
 Format[ condmap[ cmaps_List ] ] := pretty[ condmap[ cmaps ] ]
)

(
 postformat[ condmap[ cmaps_List ] ] := (
 setTemporaryPageWidth[ 2^15 ] ; condmap[ cmaps ]
 )
)

(
 normSinIntegral[ n_Integer ] := (
 Unprotect[ normSinIntegral ]
 ; normSinIntegral[ n ] = { x } ~Module~ (
   ( Sin[x]^n ) ~Integrate~ {x,0.0,Pi/2.0}
 )
 ; Protect[ normSinIntegral ]
 ; normSinIntegral[ n ]
 )
)

(
 normalizedSinIntegral :=
 { { n, _Integer }, { x, _Real } } ~Compile~ (
 Re[ (
   (2I)^(-n) * Plus @@ (
     Binomial[ n, #1 ] * (-1)^#1 * If[ n == 2#1
     , x
     , ( Exp[ I*x*(n-2#1) ] - 1 ) / I / (n-2#1)
     ] & /@ Range[ 0, n ]
   )
 ) / normSinIntegral[ n ] ]
 )
)

(
 randomAngleQuadrant[ n_Integer ] := (
 #2 & @@ #1 & @@ (
   ( normalizedSinIntegral[ n, x ] == #1 )
     ~FindRoot~ { x, 0.0, Pi/2.0 } & [ Random[] ]
 )
 )
)

(
 randomAngle[ n_Integer ] := (
 Switch[ Random[ Integer, {1,4} ]
 , 1, #1
 , 2, Pi - #1
 , 3, -#1
 , 4, -Pi + #1
 ] & [ randomAngleQuadrant[ n ] ]
 )
)

(
 randomRealVector[ n_Integer ] := (
 ( Times @@ ( Sin /@ ( #1 ~Drop~ -1 ) ) ) * Cos[ #1[[-1]] ] & /@ (
   Outer[
     #1 ~Take~ #2 &
   , { ( randomAngle[ n-1-#1 ] & /@ Range[ n-1 ] ) ~Append~ 0 }
   , Range[n]
   , 1
   ] ~Flatten~ 1
 )
 )
)

(
 randomComplexVector[ n_Integer ] :=
 #1+I#2 & @@ #1 & /@ randomRealVector[ 2n ] ~Partition~ 2
)

(
 randomKet[ space__ ] := (
 fm[ List /@ randomComplexVector[ dimension[ #1 ] ] , ket /@ #1 ]
   & [ Union[ Flatten[ { space } ] ] ]
 ) // nestify
)

(
 compareWithPermutation[ target_List , source_List ] :=
 If[ Length[ target ] == Length[ source ]
 , If[ And @@ ( Length[#] == 1 & /@ # )
 , { True, # & @@ # & /@ # }
 , { False, {} }
 ] & [ Flatten[ Position[ target, #, 1 ] ] & /@ source ]
 , { False, {} }
 ]
)

(
 compareWithPermutation[ t_, s_ ] :=
 throw[ "compareWithPermutation", ": arguments must both be lists: ", t, s ]
)

(
 equalUpToPermutation[ x_List, y_List ] := # & @@ compareWithPermutation[ x, y ]
)

(
 inversePermutation[ perm_List ] :=
 If[ #1, #2, throw[
 "inversePermutation", ": not a permutation: ", perm
] ] & @@ compareWithPermutation[ perm, Range[ Length[ perm ] ] ]
)

(
 permute[ list_List, perm_List ] := If[
 Length[ list ] != Length[ perm ]
 , throw[ "permute", ": arguments have different length: ", list, perm ]
 , list[[ # ]] & /@ inversePermutation[ perm ]
 ]
)

(

 signedPermutations[ list_List ] := If[
 Length[ list ] <= 1
 , { { list, 1 } }
 , Flatten[
   Outer[
     { { list[[#1]] } ~Join~ (#1 & @@ #2)
     , ( #2 & @@ #2 ) * ( 2*#1 ~Mod~ 2 - 1 )
     } &
   , { #1 }
   , signedPermutations[ list ~Delete~ #1 ]
   , 1, 1
   ] & /@ Range[ Length[ list ] ]
 , 2
 ]
 ]
)

(
 Protect @@ Names[ "qmatrix`*" ]
; Protect @@ Names[ "qmatrix`Private`*" ]
)

(
 End[];
)

(
 EndPackage[];
)
